// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3danimation_python.h"

// main header
#include "qt3danimation_qanimationclipdata_wrapper.h"

// Argument includes
#include <QString>
#include <Qt3DAnimation/qanimationclipdata.h>
#include <Qt3DAnimation/qchannel.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace Qt3DAnimation;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DAnimation_QAnimationClipData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DAnimation::QAnimationClipData >()))
        return -1;

    ::Qt3DAnimation::QAnimationClipData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QAnimationClipData", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QAnimationClipData::QAnimationClipData()
    // 1: QAnimationClipData::QAnimationClipData(Qt3DAnimation::QAnimationClipData)
    if (numArgs == 0) {
        overloadId = 0; // QAnimationClipData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QAnimationClipData(Qt3DAnimation::QAnimationClipData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QAnimationClipData()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QAnimationClipData()
                cptr = new ::Qt3DAnimation::QAnimationClipData();
            }
            break;
        }
        case 1: // QAnimationClipData(const Qt3DAnimation::QAnimationClipData &arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DAnimation::QAnimationClipData cppArg0_local;
            ::Qt3DAnimation::QAnimationClipData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QAnimationClipData(Qt3DAnimation::QAnimationClipData)
                cptr = new ::Qt3DAnimation::QAnimationClipData(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DAnimation::QAnimationClipData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_appendChannel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QAnimationClipData::appendChannel(Qt3DAnimation::QChannel)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QChannel_IDX]), (pyArg)))) {
        overloadId = 0; // appendChannel(Qt3DAnimation::QChannel)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "appendChannel", errInfo, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::Qt3DAnimation::QChannel cppArg0_local;
        ::Qt3DAnimation::QChannel *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // appendChannel(Qt3DAnimation::QChannel)
            cppSelf->appendChannel(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_begin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // begin()const
            const Qt3DAnimation::QChannel * cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->begin();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QChannel_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_cbegin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cbegin()const
            const Qt3DAnimation::QChannel * cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->cbegin();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QChannel_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_cend(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cend()const
            const Qt3DAnimation::QChannel * cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->cend();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QChannel_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_channelCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // channelCount()const
            int cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->channelCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_clearChannels(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // clearChannels()
            cppSelf->clearChannels();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_end(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // end()const
            const Qt3DAnimation::QChannel * cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->end();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QChannel_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_insertChannel(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "insertChannel", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QAnimationClipData::insertChannel(int,Qt3DAnimation::QChannel)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QChannel_IDX]), (pyArgs[1])))) {
        overloadId = 0; // insertChannel(int,Qt3DAnimation::QChannel)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "insertChannel", errInfo, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::Qt3DAnimation::QChannel cppArg1_local;
        ::Qt3DAnimation::QChannel *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);


        if (Shiboken::Errors::occurred() == nullptr) {
            // insertChannel(int,Qt3DAnimation::QChannel)
            cppSelf->insertChannel(cppArg0, *cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_removeChannel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QAnimationClipData::removeChannel(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // removeChannel(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "removeChannel", errInfo, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // removeChannel(int)
            cppSelf->removeChannel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipDataFunc_setName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QAnimationClipData::setName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setName", errInfo, SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setName(QString)
            cppSelf->setName(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DAnimation_QAnimationClipData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Qt3DAnimation_QAnimationClipData_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DAnimation_QAnimationClipData_methods[] = {
    {"appendChannel", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_appendChannel), METH_O, nullptr},
    {"begin", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_begin), METH_NOARGS, nullptr},
    {"cbegin", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_cbegin), METH_NOARGS, nullptr},
    {"cend", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_cend), METH_NOARGS, nullptr},
    {"channelCount", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_channelCount), METH_NOARGS, nullptr},
    {"clearChannels", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_clearChannels), METH_NOARGS, nullptr},
    {"end", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_end), METH_NOARGS, nullptr},
    {"insertChannel", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_insertChannel), METH_VARARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_isValid), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_name), METH_NOARGS, nullptr},
    {"removeChannel", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_removeChannel), METH_O, nullptr},
    {"setName", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipDataFunc_setName), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_Qt3DAnimation_QAnimationClipData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_Qt3DAnimation_QAnimationClipData_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), (pyArg)))) {
                // operator!=(const Qt3DAnimation::QAnimationClipData &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::Qt3DAnimation::QAnimationClipData cppArg0_local;
                ::Qt3DAnimation::QAnimationClipData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), (pyArg)))) {
                // operator==(const Qt3DAnimation::QAnimationClipData &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::Qt3DAnimation::QAnimationClipData cppArg0_local;
                ::Qt3DAnimation::QAnimationClipData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_Qt3DAnimation_QAnimationClipData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DAnimation_QAnimationClipData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DAnimation_QAnimationClipData_Type = nullptr;
static PyTypeObject *Sbk_Qt3DAnimation_QAnimationClipData_TypeF(void)
{
    return _Sbk_Qt3DAnimation_QAnimationClipData_Type;
}

static PyType_Slot Sbk_Qt3DAnimation_QAnimationClipData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DAnimation_QAnimationClipData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DAnimation_QAnimationClipData_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_Qt3DAnimation_QAnimationClipData_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DAnimation_QAnimationClipData_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DAnimation_QAnimationClipData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DAnimation_QAnimationClipData_spec = {
    "2:PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DAnimation_QAnimationClipData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QAnimationClipData_PythonToCpp_QAnimationClipData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DAnimation_QAnimationClipData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QAnimationClipData_PythonToCpp_QAnimationClipData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DAnimation_QAnimationClipData_TypeF()))
        return QAnimationClipData_PythonToCpp_QAnimationClipData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QAnimationClipData_PTR_CppToPython_QAnimationClipData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_Qt3DAnimation_QAnimationClipData_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QAnimationClipData_COPY_CppToPython_QAnimationClipData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::Qt3DAnimation::QAnimationClipData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_Qt3DAnimation_QAnimationClipData_TypeF(), new ::Qt3DAnimation::QAnimationClipData(*source), true, true);
}

// Python to C++ copy conversion.
static void QAnimationClipData_PythonToCpp_QAnimationClipData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::Qt3DAnimation::QAnimationClipData *>(cppOut) = *reinterpret_cast< ::Qt3DAnimation::QAnimationClipData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QAnimationClipData_PythonToCpp_QAnimationClipData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DAnimation_QAnimationClipData_TypeF()))
        return QAnimationClipData_PythonToCpp_QAnimationClipData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Qt3DAnimation_QAnimationClipData_SignatureStrings[] = {
    "1:PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData(self)",
    "0:PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData(self,arg__1:PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData)",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.appendChannel(self,c:PySide6.Qt3DAnimation.Qt3DAnimation.QChannel)",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.begin(self)->PySide6.Qt3DAnimation.Qt3DAnimation.QChannel",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.cbegin(self)->PySide6.Qt3DAnimation.Qt3DAnimation.QChannel",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.cend(self)->PySide6.Qt3DAnimation.Qt3DAnimation.QChannel",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.channelCount(self)->int",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.clearChannels(self)",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.end(self)->PySide6.Qt3DAnimation.Qt3DAnimation.QChannel",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.insertChannel(self,index:int,c:PySide6.Qt3DAnimation.Qt3DAnimation.QChannel)",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.isValid(self)->bool",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.name(self)->QString",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.removeChannel(self,index:int)",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.setName(self,name:QString)",
    "PySide6.Qt3DAnimation.Qt3DAnimation.QAnimationClipData.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t Qt3DAnimation_QAnimationClipData_SignatureByteSize = 216;
static constexpr uint8_t Qt3DAnimation_QAnimationClipData_SignatureBytes[216] = {
    0x78, 0xda, 0xbd, 0x92, 0xbd, 0x0a, 0xc2, 0x40, 0x10, 0x84, 0xfb, 0x3c, 0x49, 0x02, 0x2a, 0x06,
    0xc1, 0x22, 0x85, 0x20, 0xb1, 0x16, 0x43, 0xc0, 0xf6, 0x58, 0x93, 0x35, 0x2e, 0x5c, 0xf6, 0xc2,
    0xdd, 0x29, 0xfa, 0xf6, 0x2a, 0xf9, 0x01, 0xc5, 0x42, 0x57, 0x48, 0x77, 0x57, 0xcc, 0xcc, 0xb7,
    0xc3, 0xc4, 0xc9, 0xee, 0x96, 0x53, 0x89, 0xcb, 0x59, 0xe6, 0x17, 0x9b, 0x35, 0x53, 0x0d, 0x9e,
    0x0c, 0xbf, 0xff, 0x86, 0x67, 0xaa, 0xa9, 0xd9, 0x80, 0x87, 0xd0, 0xa1, 0x3e, 0x46, 0xc1, 0xfc,
    0x1f, 0xf9, 0x04, 0x6c, 0xa5, 0x54, 0x2c, 0xb4, 0x88, 0x02, 0x99, 0x6e, 0x06, 0x4d, 0x83, 0x5c,
    0xa6, 0x27, 0x60, 0x46, 0xdd, 0x82, 0x14, 0xdf, 0x31, 0x74, 0x1a, 0x71, 0xf2, 0x01, 0x2b, 0xe2,
    0xb6, 0xb9, 0xe9, 0xea, 0x97, 0x44, 0x69, 0x60, 0x31, 0x7e, 0xe2, 0xa3, 0xda, 0x51, 0xf3, 0x5a,
    0x79, 0x6a, 0xce, 0xec, 0xfb, 0x5c, 0x62, 0x2f, 0xb6, 0xd3, 0x08, 0xb6, 0x43, 0x72, 0xdd, 0xc6,
    0x85, 0x56, 0x23, 0x17, 0x41, 0xec, 0xd0, 0xfa, 0x97, 0x55, 0x13, 0x97, 0x78, 0x4d, 0x1e, 0x6d,
    0x8c, 0xb5, 0x6f, 0x72, 0x7b, 0xd0, 0x34, 0x9c, 0x7d, 0x30, 0x46, 0x7c, 0x0e, 0x43, 0x8d, 0xbd,
    0x4f, 0x96, 0x7b, 0x4b, 0x5c, 0x49, 0xad, 0x2c, 0xd6, 0xe6, 0x82, 0x9f, 0x9b, 0x11, 0x9f, 0xea,
    0xd0, 0x6f, 0x7b, 0xc4, 0xc9, 0x13, 0x36, 0xe9, 0x28, 0xc5, 0x8e, 0x4a, 0x15, 0xa6, 0xb9, 0x29,
    0x15, 0x46, 0xc1, 0x1d, 0x19, 0x09, 0xff, 0x04
};
#endif

PyTypeObject *init_Qt3DAnimation_QAnimationClipData(PyObject *enclosingClass)
{
    if (SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX].type != nullptr)
        return SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX].type;

    Shiboken::AutoDecRef Sbk_Qt3DAnimation_QAnimationClipData_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_Qt3DAnimation_QAnimationClipData_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QAnimationClipData",
        "Qt3DAnimation::QAnimationClipData",
        &Sbk_Qt3DAnimation_QAnimationClipData_spec,
        &Shiboken::callCppDestructor< ::Qt3DAnimation::QAnimationClipData >,
        Sbk_Qt3DAnimation_QAnimationClipData_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_Qt3DAnimation_QAnimationClipData_TypeF(); // references _Sbk_Qt3DAnimation_QAnimationClipData_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Qt3DAnimation_QAnimationClipData_SignatureStrings);
#else
    InitSignatureBytes(pyType, Qt3DAnimation_QAnimationClipData_SignatureBytes, Qt3DAnimation_QAnimationClipData_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DAnimation_QAnimationClipData_PropertyStrings);
    SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimation_QAnimationClipData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QAnimationClipData_PythonToCpp_QAnimationClipData_PTR,
        is_QAnimationClipData_PythonToCpp_QAnimationClipData_PTR_Convertible,
        QAnimationClipData_PTR_CppToPython_QAnimationClipData,
        QAnimationClipData_COPY_CppToPython_QAnimationClipData);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QAnimationClipData");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QAnimationClipData*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DAnimation::QAnimationClipData&");
    Shiboken::Conversions::registerConverterAlias(converter, "QAnimationClipData");
    Shiboken::Conversions::registerConverterAlias(converter, "QAnimationClipData*");
    Shiboken::Conversions::registerConverterAlias(converter, "QAnimationClipData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DAnimation::QAnimationClipData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QAnimationClipData_PythonToCpp_QAnimationClipData_COPY,
        is_QAnimationClipData_PythonToCpp_QAnimationClipData_COPY_Convertible);

    qRegisterMetaType< ::Qt3DAnimation::QAnimationClipData >("QAnimationClipData");
    qRegisterMetaType< ::Qt3DAnimation::QAnimationClipData >("Qt3DAnimation::QAnimationClipData");

    return pyType;
}
