// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3drender_python.h"

// main header
#include "qt3drender_qraycasterhit_wrapper.h"

// Argument includes
#include <QString>
#include <Qt3DCore/qentity.h>
#include <Qt3DCore/qnodeid.h>
#include <Qt3DRender/qraycasterhit.h>
#include <QtGui/qvectornd.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace Qt3DRender;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DRender_QRayCasterHit_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DRender::QRayCasterHit >()))
        return -1;

    ::Qt3DRender::QRayCasterHit *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[9];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2 || numArgs == 3 || numArgs == 4 || numArgs == 5 || numArgs == 6 || numArgs == 7 || numArgs == 8)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]);

    if (PyArg_UnpackTuple(args, "QRayCasterHit", 0, 9, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4]), &(pyArgs[5]), &(pyArgs[6]), &(pyArgs[7]), &(pyArgs[8])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRayCasterHit::QRayCasterHit()
    // 1: QRayCasterHit::QRayCasterHit(Qt3DRender::QRayCasterHit::HitType,Qt3DCore::QNodeId,float,QVector3D,QVector3D,uint,uint,uint,uint)
    // 2: QRayCasterHit::QRayCasterHit(Qt3DRender::QRayCasterHit)
    if (numArgs == 0) {
        overloadId = 0; // QRayCasterHit()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QRayCasterHit(Qt3DRender::QRayCasterHit)
    } else if (numArgs == 9
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_HitType_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeId_IDX]), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[2])))
        && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), (pyArgs[3])))
        && (pythonToCpp[4] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), (pyArgs[4])))
        && (pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[5])))
        && (pythonToCpp[6] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[6])))
        && (pythonToCpp[7] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[7])))
        && (pythonToCpp[8] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[8])))) {
        overloadId = 1; // QRayCasterHit(Qt3DRender::QRayCasterHit::HitType,Qt3DCore::QNodeId,float,QVector3D,QVector3D,uint,uint,uint,uint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRayCasterHit()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRayCasterHit()
                cptr = new ::Qt3DRender::QRayCasterHit();
            }
            break;
        }
        case 1: // QRayCasterHit(Qt3DRender::QRayCasterHit::HitType type, Qt3DCore::QNodeId id, float distance, const QVector3D &localIntersect, const QVector3D &worldIntersect, uint primitiveIndex, uint v1, uint v2, uint v3)
        {
            ::Qt3DRender::QRayCasterHit::HitType cppArg0{Qt3DRender::QRayCasterHit::TriangleHit};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::Qt3DCore::QNodeId cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            float cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            if (!Shiboken::Object::isValid(pyArgs[3]))
                return -1;
            ::QVector3D cppArg3_local;
            ::QVector3D *cppArg3 = &cppArg3_local;
            if (pythonToCpp[3].isValue())
                pythonToCpp[3](pyArgs[3], &cppArg3_local);
            else
                pythonToCpp[3](pyArgs[3], &cppArg3);

            if (!Shiboken::Object::isValid(pyArgs[4]))
                return -1;
            ::QVector3D cppArg4_local;
            ::QVector3D *cppArg4 = &cppArg4_local;
            if (pythonToCpp[4].isValue())
                pythonToCpp[4](pyArgs[4], &cppArg4_local);
            else
                pythonToCpp[4](pyArgs[4], &cppArg4);

            uint cppArg5;
            pythonToCpp[5](pyArgs[5], &cppArg5);
            uint cppArg6;
            pythonToCpp[6](pyArgs[6], &cppArg6);
            uint cppArg7;
            pythonToCpp[7](pyArgs[7], &cppArg7);
            uint cppArg8;
            pythonToCpp[8](pyArgs[8], &cppArg8);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRayCasterHit(Qt3DRender::QRayCasterHit::HitType,Qt3DCore::QNodeId,float,QVector3D,QVector3D,uint,uint,uint,uint)
                cptr = new ::Qt3DRender::QRayCasterHit(cppArg0, cppArg1, cppArg2, *cppArg3, *cppArg4, cppArg5, cppArg6, cppArg7, cppArg8);
            }
            break;
        }
        case 2: // QRayCasterHit(const Qt3DRender::QRayCasterHit &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DRender::QRayCasterHit cppArg0_local;
            ::Qt3DRender::QRayCasterHit *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRayCasterHit(Qt3DRender::QRayCasterHit)
                cptr = new ::Qt3DRender::QRayCasterHit(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DRender::QRayCasterHit >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_distance(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // distance()const
            float cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->distance();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_entity(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // entity()const
            Qt3DCore::QEntity * cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->entity();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QEntity_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_entityId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // entityId()const
            Qt3DCore::QNodeId cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->entityId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeId_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_localIntersection(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // localIntersection()const
            QVector3D cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->localIntersection();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_primitiveIndex(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // primitiveIndex()const
            uint cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->primitiveIndex();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_toString(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toString()
            QString cppResult = cppSelf->toString();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            Qt3DRender::QRayCasterHit::HitType cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_HitType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_vertex1Index(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // vertex1Index()const
            uint cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->vertex1Index();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_vertex2Index(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // vertex2Index()const
            uint cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->vertex2Index();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_vertex3Index(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // vertex3Index()const
            uint cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->vertex3Index();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHitFunc_worldIntersection(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // worldIntersection()const
            QVector3D cppResult = const_cast<const ::Qt3DRender::QRayCasterHit *>(cppSelf)->worldIntersection();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QRayCasterHit__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Qt3DRender_QRayCasterHit_PropertyStrings[] = {
    "distance:",
    "entity:",
    "entityId:",
    "localIntersection:",
    "primitiveIndex:",
    "type:",
    "vertex1Index:",
    "vertex2Index:",
    "vertex3Index:",
    "worldIntersection:",
    nullptr // Sentinel
};

static const char *Sbk_Qt3DRender_QRayCasterHit_EnumFlagInfo[] = {
    "HitType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DRender_QRayCasterHit_methods[] = {
    {"distance", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_distance), METH_NOARGS, nullptr},
    {"entity", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_entity), METH_NOARGS, nullptr},
    {"entityId", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_entityId), METH_NOARGS, nullptr},
    {"localIntersection", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_localIntersection), METH_NOARGS, nullptr},
    {"primitiveIndex", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_primitiveIndex), METH_NOARGS, nullptr},
    {"toString", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_toString), METH_NOARGS, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_type), METH_NOARGS, nullptr},
    {"vertex1Index", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_vertex1Index), METH_NOARGS, nullptr},
    {"vertex2Index", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_vertex2Index), METH_NOARGS, nullptr},
    {"vertex3Index", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_vertex3Index), METH_NOARGS, nullptr},
    {"worldIntersection", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHitFunc_worldIntersection), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QRayCasterHit__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DRender_QRayCasterHit_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DRender_QRayCasterHit_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DRender_QRayCasterHit_Type = nullptr;
static PyTypeObject *Sbk_Qt3DRender_QRayCasterHit_TypeF(void)
{
    return _Sbk_Qt3DRender_QRayCasterHit_Type;
}

static PyType_Slot Sbk_Qt3DRender_QRayCasterHit_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DRender_QRayCasterHit_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DRender_QRayCasterHit_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DRender_QRayCasterHit_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DRender_QRayCasterHit_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DRender_QRayCasterHit_spec = {
    "2:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DRender_QRayCasterHit_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_Qt3DRender_QRayCasterHit_HitType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::Qt3DRender::QRayCasterHit::HitType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::Qt3DRender::QRayCasterHit::HitType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_Qt3DRender_QRayCasterHit_HitType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_HitType_IDX])))
        return Enum_PythonToCpp_Qt3DRender_QRayCasterHit_HitType;
    return {};
}

static PyObject *Qt3DRender_QRayCasterHit_HitType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::Qt3DRender::QRayCasterHit::HitType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::Qt3DRender::QRayCasterHit::HitType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_HitType_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRayCasterHit_PythonToCpp_QRayCasterHit_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DRender_QRayCasterHit_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRayCasterHit_PythonToCpp_QRayCasterHit_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QRayCasterHit_TypeF()))
        return QRayCasterHit_PythonToCpp_QRayCasterHit_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRayCasterHit_PTR_CppToPython_QRayCasterHit(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_Qt3DRender_QRayCasterHit_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRayCasterHit_COPY_CppToPython_QRayCasterHit(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::Qt3DRender::QRayCasterHit *>(cppIn);
    return Shiboken::Object::newObject(Sbk_Qt3DRender_QRayCasterHit_TypeF(), new ::Qt3DRender::QRayCasterHit(*source), true, true);
}

// Python to C++ copy conversion.
static void QRayCasterHit_PythonToCpp_QRayCasterHit_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::Qt3DRender::QRayCasterHit *>(cppOut) = *reinterpret_cast< ::Qt3DRender::QRayCasterHit *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRayCasterHit_PythonToCpp_QRayCasterHit_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QRayCasterHit_TypeF()))
        return QRayCasterHit_PythonToCpp_QRayCasterHit_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Qt3DRender_QRayCasterHit_SignatureStrings[] = {
    "2:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit(self)",
    "1:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit(self,type:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.HitType,id:PySide6.Qt3DCore.Qt3DCore.QNodeId,distance:float,localIntersect:PySide6.QtGui.QVector3D,worldIntersect:PySide6.QtGui.QVector3D,primitiveIndex:uint,v1:uint,v2:uint,v3:uint)",
    "0:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit(self,other:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit)",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.distance(self)->float",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.entity(self)->PySide6.Qt3DCore.Qt3DCore.QEntity",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.entityId(self)->PySide6.Qt3DCore.Qt3DCore.QNodeId",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.localIntersection(self)->PySide6.QtGui.QVector3D",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.primitiveIndex(self)->uint",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.toString(self)->QString",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.type(self)->PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.HitType",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.vertex1Index(self)->uint",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.vertex2Index(self)->uint",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.vertex3Index(self)->uint",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.worldIntersection(self)->PySide6.QtGui.QVector3D",
    "PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t Qt3DRender_QRayCasterHit_SignatureByteSize = 281;
static constexpr uint8_t Qt3DRender_QRayCasterHit_SignatureBytes[281] = {
    0x78, 0xda, 0xad, 0x94, 0xc1, 0x4e, 0xc3, 0x30, 0x0c, 0x86, 0xef, 0x7d, 0x92, 0x55, 0x0a, 0x15,
    0x6d, 0x25, 0x0e, 0x3d, 0x70, 0xd9, 0x10, 0xf4, 0x82, 0xe8, 0x86, 0xb8, 0x56, 0x51, 0xe3, 0x81,
    0xa5, 0x90, 0x54, 0xa9, 0x57, 0xd6, 0xb7, 0x27, 0xb4, 0xab, 0xb4, 0x08, 0x04, 0x33, 0xdb, 0x21,
    0x72, 0x12, 0xe5, 0xff, 0x92, 0xfc, 0x76, 0x92, 0x15, 0x4f, 0xc3, 0x06, 0x15, 0xdc, 0x24, 0x15,
    0xe5, 0xab, 0x35, 0x18, 0x05, 0x2e, 0xe8, 0xae, 0xe5, 0xb0, 0x94, 0x1d, 0x81, 0x7b, 0x40, 0x5a,
    0x74, 0xa0, 0xb7, 0x71, 0x94, 0xb2, 0x35, 0x82, 0x86, 0x16, 0x38, 0xaa, 0xc4, 0xb7, 0x67, 0xaf,
    0x11, 0xa8, 0x02, 0xd9, 0xd2, 0x3a, 0x38, 0xea, 0x3c, 0x5a, 0x05, 0xa5, 0x12, 0x0a, 0x3b, 0x92,
    0xa6, 0x81, 0x62, 0xab, 0xad, 0x24, 0xa1, 0x6d, 0x23, 0x75, 0x69, 0x3c, 0xa9, 0x83, 0x86, 0x8e,
    0xf4, 0xf7, 0x3b, 0x4c, 0xaa, 0x17, 0x3f, 0x67, 0x5d, 0xbe, 0x12, 0x1f, 0xd6, 0x69, 0xf5, 0xf7,
    0xb2, 0xd6, 0xe1, 0x3b, 0x12, 0xf6, 0x50, 0xfa, 0x63, 0xee, 0x8b, 0x1d, 0x1a, 0x12, 0x7d, 0x7a,
    0x88, 0xd9, 0x21, 0xe6, 0x63, 0x8c, 0xa3, 0x6b, 0xbe, 0x35, 0x96, 0xde, 0xc0, 0x71, 0x64, 0x71,
    0xc4, 0x31, 0x72, 0xf6, 0x66, 0xca, 0xdd, 0xd5, 0xed, 0x68, 0x11, 0x8b, 0x00, 0x86, 0x90, 0x86,
    0x59, 0xff, 0x4b, 0x36, 0xee, 0xc6, 0x85, 0xff, 0x60, 0x97, 0xea, 0x04, 0xfa, 0x94, 0x6b, 0x16,
    0x3d, 0x2c, 0x04, 0xb4, 0xe6, 0xfb, 0x36, 0x41, 0xae, 0x59, 0xf0, 0xb0, 0x2e, 0x66, 0xf2, 0x57,
    0x19, 0xb0, 0x30, 0x64, 0x37, 0xe4, 0xd0, 0xbc, 0xce, 0x80, 0x6a, 0x1a, 0xf2, 0x18, 0xfe, 0xa5,
    0xfc, 0xe4, 0xe0, 0x89, 0x8f, 0x8c, 0xb5, 0x57, 0x0f, 0x8e, 0x60, 0x9f, 0x9e, 0x77, 0xe9, 0x09,
    0x92, 0x5d, 0x02, 0x92, 0x9f, 0x07, 0x09, 0x3f, 0x81, 0x0b, 0x97, 0x48, 0x5d, 0x37, 0xb6, 0x1d,
    0xea, 0x7a, 0x11, 0x47, 0x9f, 0x5f, 0x3b, 0xe7, 0x9c
};
#endif

PyTypeObject *init_Qt3DRender_QRayCasterHit(PyObject *enclosingClass)
{
    if (SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX].type != nullptr)
        return SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX].type;

    Shiboken::AutoDecRef Sbk_Qt3DRender_QRayCasterHit_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_Qt3DRender_QRayCasterHit_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QRayCasterHit",
        "Qt3DRender::QRayCasterHit",
        &Sbk_Qt3DRender_QRayCasterHit_spec,
        &Shiboken::callCppDestructor< ::Qt3DRender::QRayCasterHit >,
        Sbk_Qt3DRender_QRayCasterHit_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_Qt3DRender_QRayCasterHit_TypeF(); // references _Sbk_Qt3DRender_QRayCasterHit_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Qt3DRender_QRayCasterHit_SignatureStrings);
#else
    InitSignatureBytes(pyType, Qt3DRender_QRayCasterHit_SignatureBytes, Qt3DRender_QRayCasterHit_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DRender_QRayCasterHit_PropertyStrings);
    SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRayCasterHit_PythonToCpp_QRayCasterHit_PTR,
        is_QRayCasterHit_PythonToCpp_QRayCasterHit_PTR_Convertible,
        QRayCasterHit_PTR_CppToPython_QRayCasterHit,
        QRayCasterHit_COPY_CppToPython_QRayCasterHit);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QRayCasterHit");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QRayCasterHit*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QRayCasterHit&");
    Shiboken::Conversions::registerConverterAlias(converter, "QRayCasterHit");
    Shiboken::Conversions::registerConverterAlias(converter, "QRayCasterHit*");
    Shiboken::Conversions::registerConverterAlias(converter, "QRayCasterHit&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DRender::QRayCasterHit).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRayCasterHit_PythonToCpp_QRayCasterHit_COPY,
        is_QRayCasterHit_PythonToCpp_QRayCasterHit_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_Qt3DRender_QRayCasterHit_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'HitType'.
    const char *HitType_Initializer[] = {
        "TriangleHit",
        "LineHit",
        "PointHit",
        "EntityHit",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t HitType_InitializerValues[] = {
        uint8_t(Qt3DRender::QRayCasterHit::HitType::TriangleHit), //  0x00  0
        uint8_t(Qt3DRender::QRayCasterHit::HitType::LineHit),     //  0x01  1
        uint8_t(Qt3DRender::QRayCasterHit::HitType::PointHit),    //  0x02  2
        uint8_t(Qt3DRender::QRayCasterHit::HitType::EntityHit)    //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_Qt3DRender_QRayCasterHit_TypeF(),
        "2:PySide6.Qt3DRender.Qt3DRender.QRayCasterHit.HitType",
        HitType_Initializer, HitType_InitializerValues);
    SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QRayCasterHit_HitType_IDX].type = EType;
    // Register converter for enum 'Qt3DRender::QRayCasterHit::HitType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            Qt3DRender_QRayCasterHit_HitType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_Qt3DRender_QRayCasterHit_HitType,
            is_Enum_PythonToCpp_Qt3DRender_QRayCasterHit_HitType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QRayCasterHit::HitType");
        Shiboken::Conversions::registerConverterAlias(converter, "QRayCasterHit::HitType");
        Shiboken::Conversions::registerConverterAlias(converter, "HitType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'HitType' enum.

    qRegisterMetaType< ::Qt3DRender::QRayCasterHit >("QRayCasterHit");
    qRegisterMetaType< ::Qt3DRender::QRayCasterHit >("Qt3DRender::QRayCasterHit");
    qRegisterMetaType< ::Qt3DRender::QRayCasterHit::HitType >("QRayCasterHit::HitType");
    qRegisterMetaType< ::Qt3DRender::QRayCasterHit::HitType >("Qt3DRender::QRayCasterHit::HitType");

    return pyType;
}
