// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhidepthstencilclearvalue_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiDepthStencilClearValue_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiDepthStencilClearValue >()))
        return -1;

    ::QRhiDepthStencilClearValue *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiDepthStencilClearValue", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiDepthStencilClearValue::QRhiDepthStencilClearValue()
    // 1: QRhiDepthStencilClearValue::QRhiDepthStencilClearValue(QRhiDepthStencilClearValue)
    // 2: QRhiDepthStencilClearValue::QRhiDepthStencilClearValue(float,quint32)
    if (numArgs == 0) {
        overloadId = 0; // QRhiDepthStencilClearValue()
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[1])))) {
        overloadId = 2; // QRhiDepthStencilClearValue(float,quint32)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiDepthStencilClearValue(QRhiDepthStencilClearValue)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiDepthStencilClearValue()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiDepthStencilClearValue()
                cptr = new ::QRhiDepthStencilClearValue();
            }
            break;
        }
        case 1: // QRhiDepthStencilClearValue(const QRhiDepthStencilClearValue &QRhiDepthStencilClearValue)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiDepthStencilClearValue cppArg0_local;
            ::QRhiDepthStencilClearValue *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiDepthStencilClearValue(QRhiDepthStencilClearValue)
                cptr = new ::QRhiDepthStencilClearValue(*cppArg0);
            }
            break;
        }
        case 2: // QRhiDepthStencilClearValue(float d, quint32 s)
        {
            float cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            quint32 cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiDepthStencilClearValue(float,quint32)
                cptr = new ::QRhiDepthStencilClearValue(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiDepthStencilClearValue >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_depthClearValue(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // depthClearValue()const
            float cppResult = const_cast<const ::QRhiDepthStencilClearValue *>(cppSelf)->depthClearValue();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_setDepthClearValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiDepthStencilClearValue::setDepthClearValue(float)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArg)))) {
        overloadId = 0; // setDepthClearValue(float)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDepthClearValue", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]);

    // Call function/method
    {
        float cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDepthClearValue(float)
            cppSelf->setDepthClearValue(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_setStencilClearValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiDepthStencilClearValue::setStencilClearValue(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setStencilClearValue(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setStencilClearValue", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStencilClearValue(quint32)
            cppSelf->setStencilClearValue(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_stencilClearValue(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // stencilClearValue()const
            quint32 cppResult = const_cast<const ::QRhiDepthStencilClearValue *>(cppSelf)->stencilClearValue();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiDepthStencilClearValue__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiDepthStencilClearValue_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiDepthStencilClearValue_methods[] = {
    {"depthClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_depthClearValue), METH_NOARGS, nullptr},
    {"setDepthClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_setDepthClearValue), METH_O, nullptr},
    {"setStencilClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_setStencilClearValue), METH_O, nullptr},
    {"stencilClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_stencilClearValue), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValue__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QRhiDepthStencilClearValue_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), (pyArg)))) {
                // operator!=(const QRhiDepthStencilClearValue &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiDepthStencilClearValue cppArg0_local;
                ::QRhiDepthStencilClearValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), (pyArg)))) {
                // operator==(const QRhiDepthStencilClearValue &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiDepthStencilClearValue cppArg0_local;
                ::QRhiDepthStencilClearValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QRhiDepthStencilClearValue_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QRhiDepthStencilClearValue_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiDepthStencilClearValue_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRhiDepthStencilClearValue__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiDepthStencilClearValue_Type = nullptr;
static PyTypeObject *Sbk_QRhiDepthStencilClearValue_TypeF(void)
{
    return _Sbk_QRhiDepthStencilClearValue_Type;
}

static PyType_Slot Sbk_QRhiDepthStencilClearValue_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QRhiDepthStencilClearValue_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiDepthStencilClearValue_spec = {
    "2:PySide6.QtGui.QRhiDepthStencilClearValue",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiDepthStencilClearValue_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiDepthStencilClearValue_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiDepthStencilClearValue_TypeF()))
        return QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiDepthStencilClearValue_PTR_CppToPython_QRhiDepthStencilClearValue(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiDepthStencilClearValue_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRhiDepthStencilClearValue_COPY_CppToPython_QRhiDepthStencilClearValue(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiDepthStencilClearValue *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiDepthStencilClearValue_TypeF(), new ::QRhiDepthStencilClearValue(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiDepthStencilClearValue *>(cppOut) = *reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiDepthStencilClearValue_TypeF()))
        return QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiDepthStencilClearValue_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiDepthStencilClearValue(self)",
    "1:PySide6.QtGui.QRhiDepthStencilClearValue(self,QRhiDepthStencilClearValue:PySide6.QtGui.QRhiDepthStencilClearValue)",
    "0:PySide6.QtGui.QRhiDepthStencilClearValue(self,d:float,s:quint32)",
    "PySide6.QtGui.QRhiDepthStencilClearValue.depthClearValue(self)->float",
    "PySide6.QtGui.QRhiDepthStencilClearValue.setDepthClearValue(self,d:float)",
    "PySide6.QtGui.QRhiDepthStencilClearValue.setStencilClearValue(self,s:quint32)",
    "PySide6.QtGui.QRhiDepthStencilClearValue.stencilClearValue(self)->quint32",
    "PySide6.QtGui.QRhiDepthStencilClearValue.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiDepthStencilClearValue_SignatureByteSize = 144;
static constexpr uint8_t QRhiDepthStencilClearValue_SignatureBytes[144] = {
    0x78, 0xda, 0x33, 0xb2, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f,
    0xcd, 0xd4, 0x0b, 0x0c, 0xca, 0xc8, 0x74, 0x49, 0x2d, 0x28, 0xc9, 0x08, 0x2e, 0x49, 0xcd, 0x4b,
    0xce, 0xcc, 0x71, 0xce, 0x49, 0x4d, 0x2c, 0x0a, 0x4b, 0xcc, 0x29, 0x4d, 0xd5, 0x28, 0x4e, 0xcd,
    0x49, 0xd3, 0xe4, 0x32, 0x24, 0x4d, 0x83, 0x0e, 0x6e, 0x79, 0xa2, 0x0d, 0xd2, 0xe4, 0x32, 0x20,
    0xd1, 0xd2, 0x14, 0xab, 0xb4, 0x9c, 0xfc, 0xc4, 0x12, 0x9d, 0x62, 0xab, 0xc2, 0xd2, 0xcc, 0xbc,
    0x12, 0x63, 0x23, 0x4d, 0x2e, 0x62, 0x0d, 0xd0, 0x4b, 0x01, 0x09, 0xa3, 0x7b, 0x5b, 0xd7, 0x0e,
    0x6c, 0x20, 0xf1, 0xa6, 0x14, 0xa7, 0x96, 0xb8, 0x60, 0x31, 0x08, 0xe6, 0x32, 0x4d, 0x92, 0x4c,
    0xc2, 0xe1, 0x4b, 0x72, 0x7c, 0x57, 0x8c, 0x3d, 0x5a, 0x75, 0xed, 0xa0, 0x46, 0x11, 0x6f, 0x52,
    0x7c, 0x7c, 0x72, 0x7e, 0x41, 0x65, 0x7c, 0xbc, 0x86, 0x26, 0x17, 0x00, 0x34, 0x48, 0xd2, 0xa9
};
#endif

PyTypeObject *init_QRhiDepthStencilClearValue(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiDepthStencilClearValue_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiDepthStencilClearValue_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiDepthStencilClearValue",
        "QRhiDepthStencilClearValue",
        &Sbk_QRhiDepthStencilClearValue_spec,
        &Shiboken::callCppDestructor< ::QRhiDepthStencilClearValue >,
        Sbk_QRhiDepthStencilClearValue_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiDepthStencilClearValue_TypeF(); // references _Sbk_QRhiDepthStencilClearValue_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiDepthStencilClearValue_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiDepthStencilClearValue_SignatureBytes, QRhiDepthStencilClearValue_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiDepthStencilClearValue_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR,
        is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR_Convertible,
        QRhiDepthStencilClearValue_PTR_CppToPython_QRhiDepthStencilClearValue,
        QRhiDepthStencilClearValue_COPY_CppToPython_QRhiDepthStencilClearValue);

    Shiboken::Conversions::registerConverterName(converter, "QRhiDepthStencilClearValue");
    Shiboken::Conversions::registerConverterName(converter, "QRhiDepthStencilClearValue*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiDepthStencilClearValue&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiDepthStencilClearValue).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY,
        is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY_Convertible);

    qRegisterMetaType< ::QRhiDepthStencilClearValue >("QRhiDepthStencilClearValue");

    return pyType;
}
