// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitextureuploadentry_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureUploadEntry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureUploadEntry >()))
        return -1;

    ::QRhiTextureUploadEntry *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);

    if (PyArg_UnpackTuple(args, "QRhiTextureUploadEntry", 0, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::QRhiTextureUploadEntry()
    // 1: QRhiTextureUploadEntry::QRhiTextureUploadEntry(QRhiTextureUploadEntry)
    // 2: QRhiTextureUploadEntry::QRhiTextureUploadEntry(int,int,QRhiTextureSubresourceUploadDescription)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureUploadEntry()
    } else if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), (pyArgs[2])))) {
        overloadId = 2; // QRhiTextureUploadEntry(int,int,QRhiTextureSubresourceUploadDescription)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiTextureUploadEntry(QRhiTextureUploadEntry)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureUploadEntry()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadEntry()
                cptr = new ::QRhiTextureUploadEntry();
            }
            break;
        }
        case 1: // QRhiTextureUploadEntry(const QRhiTextureUploadEntry &QRhiTextureUploadEntry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureUploadEntry cppArg0_local;
            ::QRhiTextureUploadEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadEntry(QRhiTextureUploadEntry)
                cptr = new ::QRhiTextureUploadEntry(*cppArg0);
            }
            break;
        }
        case 2: // QRhiTextureUploadEntry(int layer, int level, const QRhiTextureSubresourceUploadDescription &desc)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QRhiTextureSubresourceUploadDescription cppArg2_local;
            ::QRhiTextureSubresourceUploadDescription *cppArg2 = &cppArg2_local;
            if (pythonToCpp[2].isValue())
                pythonToCpp[2](pyArgs[2], &cppArg2_local);
            else
                pythonToCpp[2](pyArgs[2], &cppArg2);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadEntry(int,int,QRhiTextureSubresourceUploadDescription)
                cptr = new ::QRhiTextureUploadEntry(cppArg0, cppArg1, *cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureUploadEntry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_description(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // description()const
            QRhiTextureSubresourceUploadDescription cppResult = const_cast<const ::QRhiTextureUploadEntry *>(cppSelf)->description();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_layer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // layer()const
            int cppResult = const_cast<const ::QRhiTextureUploadEntry *>(cppSelf)->layer();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_level(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // level()const
            int cppResult = const_cast<const ::QRhiTextureUploadEntry *>(cppSelf)->level();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_setDescription(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::setDescription(QRhiTextureSubresourceUploadDescription)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), (pyArg)))) {
        overloadId = 0; // setDescription(QRhiTextureSubresourceUploadDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDescription", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRhiTextureSubresourceUploadDescription cppArg0_local;
        ::QRhiTextureSubresourceUploadDescription *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setDescription(QRhiTextureSubresourceUploadDescription)
            cppSelf->setDescription(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_setLayer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::setLayer(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setLayer(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setLayer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLayer(int)
            cppSelf->setLayer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_setLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::setLevel(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setLevel(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setLevel", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLevel(int)
            cppSelf->setLevel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadEntry__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureUploadEntry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureUploadEntry_methods[] = {
    {"description", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_description), METH_NOARGS, nullptr},
    {"layer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_layer), METH_NOARGS, nullptr},
    {"level", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_level), METH_NOARGS, nullptr},
    {"setDescription", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_setDescription), METH_O, nullptr},
    {"setLayer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_setLayer), METH_O, nullptr},
    {"setLevel", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_setLevel), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntry__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureUploadEntry_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureUploadEntry_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureUploadEntry_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureUploadEntry_TypeF(void)
{
    return _Sbk_QRhiTextureUploadEntry_Type;
}

static PyType_Slot Sbk_QRhiTextureUploadEntry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureUploadEntry_spec = {
    "2:PySide6.QtGui.QRhiTextureUploadEntry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureUploadEntry_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureUploadEntry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadEntry_TypeF()))
        return QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureUploadEntry_PTR_CppToPython_QRhiTextureUploadEntry(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiTextureUploadEntry_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRhiTextureUploadEntry_COPY_CppToPython_QRhiTextureUploadEntry(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureUploadEntry *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureUploadEntry_TypeF(), new ::QRhiTextureUploadEntry(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureUploadEntry *>(cppOut) = *reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadEntry_TypeF()))
        return QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiTextureUploadEntry_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiTextureUploadEntry(self)",
    "1:PySide6.QtGui.QRhiTextureUploadEntry(self,QRhiTextureUploadEntry:PySide6.QtGui.QRhiTextureUploadEntry)",
    "0:PySide6.QtGui.QRhiTextureUploadEntry(self,layer:int,level:int,desc:PySide6.QtGui.QRhiTextureSubresourceUploadDescription)",
    "PySide6.QtGui.QRhiTextureUploadEntry.description(self)->PySide6.QtGui.QRhiTextureSubresourceUploadDescription",
    "PySide6.QtGui.QRhiTextureUploadEntry.layer(self)->int",
    "PySide6.QtGui.QRhiTextureUploadEntry.level(self)->int",
    "PySide6.QtGui.QRhiTextureUploadEntry.setDescription(self,desc:PySide6.QtGui.QRhiTextureSubresourceUploadDescription)",
    "PySide6.QtGui.QRhiTextureUploadEntry.setLayer(self,layer:int)",
    "PySide6.QtGui.QRhiTextureUploadEntry.setLevel(self,level:int)",
    "PySide6.QtGui.QRhiTextureUploadEntry.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiTextureUploadEntry_SignatureByteSize = 182;
static constexpr uint8_t QRhiTextureUploadEntry_SignatureBytes[182] = {
    0x78, 0xda, 0x33, 0xb2, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f,
    0xcd, 0xd4, 0x0b, 0x0c, 0xca, 0xc8, 0x0c, 0x49, 0xad, 0x28, 0x29, 0x2d, 0x4a, 0x0d, 0x2d, 0xc8,
    0xc9, 0x4f, 0x4c, 0x71, 0xcd, 0x2b, 0x29, 0xaa, 0xd4, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4, 0x32,
    0x24, 0x5e, 0xb1, 0x0e, 0x76, 0x39, 0xa2, 0x0c, 0xd0, 0xe4, 0x32, 0x20, 0xc1, 0xa2, 0x9c, 0xc4,
    0xca, 0xd4, 0x22, 0xab, 0xcc, 0xbc, 0x12, 0x9d, 0x9c, 0xd4, 0xb2, 0xd4, 0x1c, 0x30, 0x2b, 0x25,
    0xb5, 0x38, 0x19, 0xb7, 0x11, 0xc1, 0xa5, 0x49, 0x45, 0xa9, 0xc5, 0xf9, 0xa5, 0x45, 0xc9, 0x50,
    0xd3, 0x5c, 0x80, 0xca, 0x8b, 0x32, 0x0b, 0x4a, 0x32, 0xf3, 0xf3, 0x34, 0xb9, 0x88, 0xb1, 0x59,
    0x2f, 0x05, 0xa1, 0x03, 0x12, 0x36, 0xba, 0x76, 0x64, 0x59, 0x47, 0x9c, 0x6d, 0x60, 0x2f, 0xc2,
    0xec, 0x01, 0xfa, 0x8f, 0x48, 0x5d, 0xa0, 0xe0, 0x20, 0x59, 0x57, 0x71, 0x6a, 0x89, 0x0b, 0x9a,
    0xe7, 0x68, 0x1f, 0x9c, 0x40, 0x4b, 0x7d, 0xe0, 0x7e, 0x44, 0xc4, 0x28, 0x09, 0xba, 0xe1, 0x7e,
    0x45, 0xa4, 0x02, 0x22, 0x75, 0xc7, 0xc7, 0x27, 0xe7, 0x17, 0x54, 0xc6, 0xc7, 0x6b, 0x68, 0x72,
    0x01, 0x00, 0x8c, 0x69, 0x21, 0xf9
};
#endif

PyTypeObject *init_QRhiTextureUploadEntry(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiTextureUploadEntry_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiTextureUploadEntry_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureUploadEntry",
        "QRhiTextureUploadEntry",
        &Sbk_QRhiTextureUploadEntry_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureUploadEntry >,
        Sbk_QRhiTextureUploadEntry_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureUploadEntry_TypeF(); // references _Sbk_QRhiTextureUploadEntry_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiTextureUploadEntry_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiTextureUploadEntry_SignatureBytes, QRhiTextureUploadEntry_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureUploadEntry_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR,
        is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR_Convertible,
        QRhiTextureUploadEntry_PTR_CppToPython_QRhiTextureUploadEntry,
        QRhiTextureUploadEntry_COPY_CppToPython_QRhiTextureUploadEntry);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadEntry");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadEntry*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadEntry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureUploadEntry).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY,
        is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY_Convertible);

    qRegisterMetaType< ::QRhiTextureUploadEntry >("QRhiTextureUploadEntry");

    return pyType;
}
