// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhivertexinputattribute_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiVertexInputAttribute_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiVertexInputAttribute >()))
        return -1;

    ::QRhiVertexInputAttribute *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[5];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 5));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
    if (numArgs == 2 || numArgs == 3)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    if (PyArg_ParseTuple(args, "|OOOOO:QRhiVertexInputAttribute", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiVertexInputAttribute::QRhiVertexInputAttribute()
    // 1: QRhiVertexInputAttribute::QRhiVertexInputAttribute(QRhiVertexInputAttribute)
    // 2: QRhiVertexInputAttribute::QRhiVertexInputAttribute(int,int,QRhiVertexInputAttribute::Format,quint32,int=)
    if (numArgs == 0) {
        overloadId = 0; // QRhiVertexInputAttribute()
    } else if (numArgs >= 4
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX])))->converter, (pyArgs[2])))
        && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[3])))) {
        if (numArgs == 4) {
            overloadId = 2; // QRhiVertexInputAttribute(int,int,QRhiVertexInputAttribute::Format,quint32,int)
        } else if (numArgs >= 5
            && (pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[4])))) {
            overloadId = 2; // QRhiVertexInputAttribute(int,int,QRhiVertexInputAttribute::Format,quint32,int)
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiVertexInputAttribute(QRhiVertexInputAttribute)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiVertexInputAttribute()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
            }

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiVertexInputAttribute()
                cptr = new ::QRhiVertexInputAttribute();
            }
            break;
        }
        case 1: // QRhiVertexInputAttribute(const QRhiVertexInputAttribute &QRhiVertexInputAttribute)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiVertexInputAttribute cppArg0_local;
            ::QRhiVertexInputAttribute *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiVertexInputAttribute(QRhiVertexInputAttribute)
                cptr = new ::QRhiVertexInputAttribute(*cppArg0);
            }
            break;
        }
        case 2: // QRhiVertexInputAttribute(int binding, int location, QRhiVertexInputAttribute::Format format, quint32 offset, int matrixSlice)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_matrixSlice = Shiboken::String::createStaticString("matrixSlice");
                if (PyDict_Contains(kwds, key_matrixSlice) != 0) {
                    value = PyDict_GetItem(kwds, key_matrixSlice);
                    if (value != nullptr && pyArgs[4] != nullptr ) {
                        errInfo.reset(key_matrixSlice);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[4] = value;
                        if (!(pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[4]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_matrixSlice);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);
                }
            }
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QRhiVertexInputAttribute::Format cppArg2{QRhiVertexInputAttribute::Float4};
            pythonToCpp[2](pyArgs[2], &cppArg2);
            quint32 cppArg3;
            pythonToCpp[3](pyArgs[3], &cppArg3);
            int cppArg4 = -1;
            if (pythonToCpp[4])
                pythonToCpp[4](pyArgs[4], &cppArg4);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiVertexInputAttribute(int,int,QRhiVertexInputAttribute::Format,quint32,int)
                cptr = new ::QRhiVertexInputAttribute(cppArg0, cppArg1, cppArg2, cppArg3, cppArg4);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiVertexInputAttribute >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_binding(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // binding()const
            int cppResult = const_cast<const ::QRhiVertexInputAttribute *>(cppSelf)->binding();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_format(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // format()const
            QRhiVertexInputAttribute::Format cppResult = const_cast<const ::QRhiVertexInputAttribute *>(cppSelf)->format();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_location(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // location()const
            int cppResult = const_cast<const ::QRhiVertexInputAttribute *>(cppSelf)->location();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_matrixSlice(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // matrixSlice()const
            int cppResult = const_cast<const ::QRhiVertexInputAttribute *>(cppSelf)->matrixSlice();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_offset(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // offset()const
            quint32 cppResult = const_cast<const ::QRhiVertexInputAttribute *>(cppSelf)->offset();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_setBinding(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputAttribute::setBinding(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setBinding(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setBinding", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setBinding(int)
            cppSelf->setBinding(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_setFormat(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputAttribute::setFormat(QRhiVertexInputAttribute::Format)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setFormat(QRhiVertexInputAttribute::Format)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setFormat", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    // Call function/method
    {
        ::QRhiVertexInputAttribute::Format cppArg0{QRhiVertexInputAttribute::Float4};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFormat(QRhiVertexInputAttribute::Format)
            cppSelf->setFormat(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_setLocation(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputAttribute::setLocation(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setLocation(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setLocation", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLocation(int)
            cppSelf->setLocation(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_setMatrixSlice(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputAttribute::setMatrixSlice(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setMatrixSlice(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setMatrixSlice", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setMatrixSlice(int)
            cppSelf->setMatrixSlice(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputAttributeFunc_setOffset(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputAttribute::setOffset(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setOffset(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setOffset", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setOffset(quint32)
            cppSelf->setOffset(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputAttribute__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiVertexInputAttribute_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QRhiVertexInputAttribute_EnumFlagInfo[] = {
    "Format:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiVertexInputAttribute_methods[] = {
    {"binding", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_binding), METH_NOARGS, nullptr},
    {"format", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_format), METH_NOARGS, nullptr},
    {"location", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_location), METH_NOARGS, nullptr},
    {"matrixSlice", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_matrixSlice), METH_NOARGS, nullptr},
    {"offset", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_offset), METH_NOARGS, nullptr},
    {"setBinding", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_setBinding), METH_O, nullptr},
    {"setFormat", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_setFormat), METH_O, nullptr},
    {"setLocation", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_setLocation), METH_O, nullptr},
    {"setMatrixSlice", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_setMatrixSlice), METH_O, nullptr},
    {"setOffset", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttributeFunc_setOffset), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputAttribute__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QRhiVertexInputAttribute_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), (pyArg)))) {
                // operator!=(const QRhiVertexInputAttribute &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiVertexInputAttribute cppArg0_local;
                ::QRhiVertexInputAttribute *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), (pyArg)))) {
                // operator==(const QRhiVertexInputAttribute &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiVertexInputAttribute cppArg0_local;
                ::QRhiVertexInputAttribute *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QRhiVertexInputAttribute_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QRhiVertexInputAttribute_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiVertexInputAttribute_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRhiVertexInputAttribute__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiVertexInputAttribute_Type = nullptr;
static PyTypeObject *Sbk_QRhiVertexInputAttribute_TypeF(void)
{
    return _Sbk_QRhiVertexInputAttribute_Type;
}

static PyType_Slot Sbk_QRhiVertexInputAttribute_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRhiVertexInputAttribute__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QRhiVertexInputAttribute_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiVertexInputAttribute_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiVertexInputAttribute_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QRhiVertexInputAttribute_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiVertexInputAttribute_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiVertexInputAttribute_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiVertexInputAttribute_spec = {
    "2:PySide6.QtGui.QRhiVertexInputAttribute",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiVertexInputAttribute_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QRhiVertexInputAttribute_Format(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QRhiVertexInputAttribute::Format>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QRhiVertexInputAttribute::Format *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QRhiVertexInputAttribute_Format_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX])))
        return Enum_PythonToCpp_QRhiVertexInputAttribute_Format;
    return {};
}

static PyObject *QRhiVertexInputAttribute_Format_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QRhiVertexInputAttribute::Format>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QRhiVertexInputAttribute::Format *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiVertexInputAttribute_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiVertexInputAttribute_TypeF()))
        return QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiVertexInputAttribute_PTR_CppToPython_QRhiVertexInputAttribute(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiVertexInputAttribute_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRhiVertexInputAttribute_COPY_CppToPython_QRhiVertexInputAttribute(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiVertexInputAttribute *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiVertexInputAttribute_TypeF(), new ::QRhiVertexInputAttribute(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiVertexInputAttribute *>(cppOut) = *reinterpret_cast< ::QRhiVertexInputAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiVertexInputAttribute_TypeF()))
        return QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiVertexInputAttribute_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiVertexInputAttribute(self)",
    "1:PySide6.QtGui.QRhiVertexInputAttribute(self,QRhiVertexInputAttribute:PySide6.QtGui.QRhiVertexInputAttribute)",
    "0:PySide6.QtGui.QRhiVertexInputAttribute(self,binding:int,location:int,format:PySide6.QtGui.QRhiVertexInputAttribute.Format,offset:quint32,matrixSlice:int=-1)",
    "PySide6.QtGui.QRhiVertexInputAttribute.binding(self)->int",
    "PySide6.QtGui.QRhiVertexInputAttribute.format(self)->PySide6.QtGui.QRhiVertexInputAttribute.Format",
    "PySide6.QtGui.QRhiVertexInputAttribute.location(self)->int",
    "PySide6.QtGui.QRhiVertexInputAttribute.matrixSlice(self)->int",
    "PySide6.QtGui.QRhiVertexInputAttribute.offset(self)->quint32",
    "PySide6.QtGui.QRhiVertexInputAttribute.setBinding(self,b:int)",
    "PySide6.QtGui.QRhiVertexInputAttribute.setFormat(self,f:PySide6.QtGui.QRhiVertexInputAttribute.Format)",
    "PySide6.QtGui.QRhiVertexInputAttribute.setLocation(self,loc:int)",
    "PySide6.QtGui.QRhiVertexInputAttribute.setMatrixSlice(self,slice:int)",
    "PySide6.QtGui.QRhiVertexInputAttribute.setOffset(self,ofs:quint32)",
    "PySide6.QtGui.QRhiVertexInputAttribute.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiVertexInputAttribute_SignatureByteSize = 234;
static constexpr uint8_t QRhiVertexInputAttribute_SignatureBytes[234] = {
    0x78, 0xda, 0x9d, 0x92, 0x5f, 0x0b, 0x82, 0x30, 0x14, 0xc5, 0xdf, 0xfd, 0x24, 0x0e, 0xa6, 0xf4,
    0x07, 0x7a, 0x10, 0x0a, 0xea, 0xc1, 0x08, 0x8a, 0xb2, 0xa0, 0x57, 0x49, 0xdd, 0xea, 0x82, 0x6d,
    0xa6, 0x57, 0xd0, 0x6f, 0xdf, 0xcc, 0x46, 0x12, 0x04, 0x5b, 0x8f, 0xdb, 0xee, 0x39, 0xf7, 0xf0,
    0xdb, 0x99, 0x04, 0x87, 0xf6, 0x04, 0x19, 0x9b, 0xf9, 0x11, 0xae, 0x6b, 0xf0, 0xa3, 0xe3, 0x0d,
    0xce, 0xac, 0x44, 0xd6, 0x6c, 0x44, 0x51, 0xe3, 0x12, 0xb1, 0x84, 0xa4, 0x46, 0xe6, 0x56, 0x2c,
    0xe7, 0xc4, 0x19, 0xdb, 0x8c, 0xd3, 0x5f, 0xaf, 0x86, 0x26, 0xc4, 0x19, 0x59, 0xad, 0x4b, 0x40,
    0x64, 0x20, 0xae, 0x01, 0x08, 0xa4, 0xb9, 0x4c, 0x2f, 0x08, 0x52, 0xbc, 0x0e, 0x5c, 0x96, 0xf7,
    0x0b, 0x1a, 0x7a, 0xf9, 0xe1, 0x6b, 0x9a, 0x4a, 0xce, 0x2b, 0x86, 0xc1, 0xa3, 0x56, 0x0e, 0xd3,
    0x09, 0x55, 0x57, 0x25, 0x34, 0xa7, 0x1c, 0x52, 0xd6, 0x79, 0xce, 0xbd, 0x31, 0x71, 0x0c, 0x0d,
    0xdf, 0xb9, 0x7a, 0x84, 0xde, 0x42, 0xa9, 0x4d, 0x95, 0x7d, 0x70, 0x2d, 0xb4, 0xca, 0x6f, 0xba,
    0x42, 0x83, 0xfa, 0x23, 0xdd, 0x00, 0xc9, 0x1f, 0xea, 0x9e, 0xaf, 0x16, 0xbe, 0x31, 0x9b, 0x8a,
    0x95, 0x72, 0x35, 0xa0, 0x4a, 0x93, 0xee, 0x4f, 0x88, 0x85, 0x3a, 0xfc, 0x90, 0xa5, 0xdc, 0xae,
    0x19, 0x36, 0x6b, 0xb6, 0x43, 0xba, 0x5d, 0x29, 0x6d, 0x73, 0xee, 0xbe, 0x18, 0xd3, 0x4a, 0x37,
    0xd0, 0xc6, 0x65, 0xff, 0x61, 0xad, 0x7a, 0x5d, 0xe9, 0x52, 0x1b, 0x5b, 0xc4, 0x71, 0x2a, 0x8b,
    0x36, 0x8e, 0x5d, 0xe2, 0x3c, 0x01, 0x89, 0x9b, 0x8c, 0xa7
};
#endif

PyTypeObject *init_QRhiVertexInputAttribute(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiVertexInputAttribute_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiVertexInputAttribute_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiVertexInputAttribute",
        "QRhiVertexInputAttribute",
        &Sbk_QRhiVertexInputAttribute_spec,
        &Shiboken::callCppDestructor< ::QRhiVertexInputAttribute >,
        Sbk_QRhiVertexInputAttribute_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiVertexInputAttribute_TypeF(); // references _Sbk_QRhiVertexInputAttribute_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiVertexInputAttribute_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiVertexInputAttribute_SignatureBytes, QRhiVertexInputAttribute_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiVertexInputAttribute_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_PTR,
        is_QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_PTR_Convertible,
        QRhiVertexInputAttribute_PTR_CppToPython_QRhiVertexInputAttribute,
        QRhiVertexInputAttribute_COPY_CppToPython_QRhiVertexInputAttribute);

    Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputAttribute");
    Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputAttribute*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputAttribute&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiVertexInputAttribute).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_COPY,
        is_QRhiVertexInputAttribute_PythonToCpp_QRhiVertexInputAttribute_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QRhiVertexInputAttribute_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Format'.
    const char *Format_Initializer[] = {
        "Float4",
        "Float3",
        "Float2",
        "Float",
        "UNormByte4",
        "UNormByte2",
        "UNormByte",
        "UInt4",
        "UInt3",
        "UInt2",
        "UInt",
        "SInt4",
        "SInt3",
        "SInt2",
        "SInt",
        "Half4",
        "Half3",
        "Half2",
        "Half",
        "UShort4",
        "UShort3",
        "UShort2",
        "UShort",
        "SShort4",
        "SShort3",
        "SShort2",
        "SShort",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Format_InitializerValues[] = {
        uint8_t(QRhiVertexInputAttribute::Format::Float4),     //  0x00  0
        uint8_t(QRhiVertexInputAttribute::Format::Float3),     //  0x01  1
        uint8_t(QRhiVertexInputAttribute::Format::Float2),     //  0x02  2
        uint8_t(QRhiVertexInputAttribute::Format::Float),      //  0x03  3
        uint8_t(QRhiVertexInputAttribute::Format::UNormByte4), //  0x04  4
        uint8_t(QRhiVertexInputAttribute::Format::UNormByte2), //  0x05  5
        uint8_t(QRhiVertexInputAttribute::Format::UNormByte),  //  0x06  6
        uint8_t(QRhiVertexInputAttribute::Format::UInt4),      //  0x07  7
        uint8_t(QRhiVertexInputAttribute::Format::UInt3),      //  0x08  8
        uint8_t(QRhiVertexInputAttribute::Format::UInt2),      //  0x09  9
        uint8_t(QRhiVertexInputAttribute::Format::UInt),       //  0x0a  10
        uint8_t(QRhiVertexInputAttribute::Format::SInt4),      //  0x0b  11
        uint8_t(QRhiVertexInputAttribute::Format::SInt3),      //  0x0c  12
        uint8_t(QRhiVertexInputAttribute::Format::SInt2),      //  0x0d  13
        uint8_t(QRhiVertexInputAttribute::Format::SInt),       //  0x0e  14
        uint8_t(QRhiVertexInputAttribute::Format::Half4),      //  0x0f  15
        uint8_t(QRhiVertexInputAttribute::Format::Half3),      //  0x10  16
        uint8_t(QRhiVertexInputAttribute::Format::Half2),      //  0x11  17
        uint8_t(QRhiVertexInputAttribute::Format::Half),       //  0x12  18
        uint8_t(QRhiVertexInputAttribute::Format::UShort4),    //  0x13  19
        uint8_t(QRhiVertexInputAttribute::Format::UShort3),    //  0x14  20
        uint8_t(QRhiVertexInputAttribute::Format::UShort2),    //  0x15  21
        uint8_t(QRhiVertexInputAttribute::Format::UShort),     //  0x16  22
        uint8_t(QRhiVertexInputAttribute::Format::SShort4),    //  0x17  23
        uint8_t(QRhiVertexInputAttribute::Format::SShort3),    //  0x18  24
        uint8_t(QRhiVertexInputAttribute::Format::SShort2),    //  0x19  25
        uint8_t(QRhiVertexInputAttribute::Format::SShort)      //  0x1a  26
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QRhiVertexInputAttribute_TypeF(),
        "2:PySide6.QtGui.QRhiVertexInputAttribute.Format",
        Format_Initializer, Format_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX].type = EType;
    // Register converter for enum 'QRhiVertexInputAttribute::Format'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QRhiVertexInputAttribute_Format_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QRhiVertexInputAttribute_Format,
            is_Enum_PythonToCpp_QRhiVertexInputAttribute_Format_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputAttribute::Format");
        Shiboken::Conversions::registerConverterAlias(converter, "Format");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'Format' enum.

    qRegisterMetaType< ::QRhiVertexInputAttribute >("QRhiVertexInputAttribute");
    qRegisterMetaType< ::QRhiVertexInputAttribute::Format >("QRhiVertexInputAttribute::Format");

    return pyType;
}
