// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qthelp_python.h"

// main header
#include "qhelpglobal_wrapper.h"

// Argument includes
#include <QString>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QHelpGlobal_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QHelpGlobal >()))
        return -1;

    ::QHelpGlobal *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QHelpGlobal", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QHelpGlobal::QHelpGlobal()
    // 1: QHelpGlobal::QHelpGlobal(QHelpGlobal)
    if (numArgs == 0) {
        overloadId = 0; // QHelpGlobal()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QHelpGlobal(QHelpGlobal)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QHelpGlobal()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QHelpGlobal()
                cptr = new ::QHelpGlobal();
            }
            break;
        }
        case 1: // QHelpGlobal(const QHelpGlobal &QHelpGlobal)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QHelpGlobal cppArg0_local;
            ::QHelpGlobal *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QHelpGlobal(QHelpGlobal)
                cptr = new ::QHelpGlobal(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QHelpGlobal >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QHelpGlobalFunc_documentTitle(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QHelpGlobal::documentTitle(QString)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // documentTitle(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "documentTitle", errInfo, SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // documentTitle(QString)
            QString cppResult = ::QHelpGlobal::documentTitle(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpGlobalFunc_uniquifyConnectionName(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "uniquifyConnectionName", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QHelpGlobal::uniquifyConnectionName(QString,void*)->QString
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[1])))) {
        overloadId = 0; // uniquifyConnectionName(QString,void*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "uniquifyConnectionName", errInfo, SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        void* cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // uniquifyConnectionName(QString,void*)
            QString cppResult = ::QHelpGlobal::uniquifyConnectionName(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpGlobal__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QHelpGlobal *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QHelpGlobal_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QHelpGlobal_methods[] = {
    {"documentTitle", reinterpret_cast<PyCFunction>(Sbk_QHelpGlobalFunc_documentTitle), METH_O|METH_STATIC, nullptr},
    {"uniquifyConnectionName", reinterpret_cast<PyCFunction>(Sbk_QHelpGlobalFunc_uniquifyConnectionName), METH_VARARGS|METH_STATIC, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QHelpGlobal__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QHelpGlobal_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QHelpGlobal_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QHelpGlobal_Type = nullptr;
static PyTypeObject *Sbk_QHelpGlobal_TypeF(void)
{
    return _Sbk_QHelpGlobal_Type;
}

static PyType_Slot Sbk_QHelpGlobal_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QHelpGlobal_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QHelpGlobal_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QHelpGlobal_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QHelpGlobal_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QHelpGlobal_spec = {
    "2:PySide6.QtHelp.QHelpGlobal",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QHelpGlobal_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QHelpGlobal_PythonToCpp_QHelpGlobal_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QHelpGlobal_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QHelpGlobal_PythonToCpp_QHelpGlobal_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QHelpGlobal_TypeF()))
        return QHelpGlobal_PythonToCpp_QHelpGlobal_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QHelpGlobal_PTR_CppToPython_QHelpGlobal(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QHelpGlobal_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QHelpGlobal_COPY_CppToPython_QHelpGlobal(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QHelpGlobal *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QHelpGlobal_TypeF(), new ::QHelpGlobal(*source), true, true);
}

// Python to C++ copy conversion.
static void QHelpGlobal_PythonToCpp_QHelpGlobal_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QHelpGlobal *>(cppOut) = *reinterpret_cast< ::QHelpGlobal *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QHelpGlobal_PythonToCpp_QHelpGlobal_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QHelpGlobal_TypeF()))
        return QHelpGlobal_PythonToCpp_QHelpGlobal_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QHelpGlobal_SignatureStrings[] = {
    "1:PySide6.QtHelp.QHelpGlobal(self)",
    "0:PySide6.QtHelp.QHelpGlobal(self,QHelpGlobal:PySide6.QtHelp.QHelpGlobal)",
    "PySide6.QtHelp.QHelpGlobal.documentTitle(content:QString)->QString",
    "PySide6.QtHelp.QHelpGlobal.uniquifyConnectionName(name:QString,pointer:void)->QString",
    "PySide6.QtHelp.QHelpGlobal.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QHelpGlobal_SignatureByteSize = 141;
static constexpr uint8_t QHelpGlobal_SignatureBytes[141] = {
    0x78, 0xda, 0x8d, 0x8c, 0xbd, 0x0a, 0xc2, 0x30, 0x14, 0x85, 0xf7, 0x3e, 0x49, 0x02, 0x35, 0xe8,
    0xe2, 0x90, 0xc1, 0xc5, 0x41, 0x27, 0x31, 0xd4, 0x3d, 0xd4, 0xe4, 0x56, 0x2e, 0xa4, 0xf7, 0xc6,
    0x9a, 0x08, 0x79, 0x7b, 0x23, 0x28, 0xb8, 0x58, 0x5d, 0x0e, 0xe7, 0x8f, 0x6f, 0xa5, 0x8f, 0xa5,
    0x43, 0x0f, 0x6b, 0x65, 0xd2, 0x1e, 0x42, 0x54, 0xe6, 0xa9, 0xbb, 0xc0, 0xe7, 0x3e, 0x88, 0x1b,
    0x84, 0x41, 0x36, 0xcb, 0x5f, 0x97, 0xf6, 0xa3, 0x98, 0xf9, 0xca, 0xe6, 0xfb, 0xa6, 0x3c, 0xbb,
    0x3c, 0x02, 0xa5, 0x13, 0xa6, 0x00, 0xc2, 0x31, 0xa5, 0x1a, 0xb4, 0xe9, 0xd2, 0x84, 0x74, 0x91,
    0x8b, 0xcd, 0xcb, 0xcd, 0x21, 0x32, 0xe1, 0x35, 0xe3, 0x50, 0xb6, 0x4c, 0x04, 0x2e, 0x21, 0xd3,
    0xa1, 0x1f, 0x41, 0x50, 0x95, 0x37, 0xa8, 0x8d, 0x8c, 0x95, 0x3c, 0xe9, 0x3b, 0xa3, 0xff, 0x8f,
    0x6a, 0xad, 0xe3, 0x58, 0xac, 0x15, 0xb2, 0x79, 0x00, 0x47, 0x98, 0x6a, 0xe4
};
#endif

PyTypeObject *init_QHelpGlobal(PyObject *module)
{
    if (SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX].type != nullptr)
        return SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX].type;

    Shiboken::AutoDecRef Sbk_QHelpGlobal_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QHelpGlobal_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QHelpGlobal",
        "QHelpGlobal",
        &Sbk_QHelpGlobal_spec,
        &Shiboken::callCppDestructor< ::QHelpGlobal >,
        Sbk_QHelpGlobal_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QHelpGlobal_TypeF(); // references _Sbk_QHelpGlobal_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QHelpGlobal_SignatureStrings);
#else
    InitSignatureBytes(pyType, QHelpGlobal_SignatureBytes, QHelpGlobal_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QHelpGlobal_PropertyStrings);
    SbkPySide6_QtHelpTypeStructs[SBK_QHelpGlobal_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QHelpGlobal_PythonToCpp_QHelpGlobal_PTR,
        is_QHelpGlobal_PythonToCpp_QHelpGlobal_PTR_Convertible,
        QHelpGlobal_PTR_CppToPython_QHelpGlobal,
        QHelpGlobal_COPY_CppToPython_QHelpGlobal);

    Shiboken::Conversions::registerConverterName(converter, "QHelpGlobal");
    Shiboken::Conversions::registerConverterName(converter, "QHelpGlobal*");
    Shiboken::Conversions::registerConverterName(converter, "QHelpGlobal&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QHelpGlobal).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QHelpGlobal_PythonToCpp_QHelpGlobal_COPY,
        is_QHelpGlobal_PythonToCpp_QHelpGlobal_COPY_Convertible);

    qRegisterMetaType< ::QHelpGlobal >("QHelpGlobal");

    return pyType;
}
