// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtlocation_python.h"

// main header
#include "qplaceattribute_wrapper.h"

// Argument includes
#include <QString>
#include <QtLocation/qplaceattribute.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QPlaceAttribute_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QPlaceAttribute >()))
        return -1;

    ::QPlaceAttribute *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QPlaceAttribute", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QPlaceAttribute::QPlaceAttribute()
    // 1: QPlaceAttribute::QPlaceAttribute(QPlaceAttribute)
    if (numArgs == 0) {
        overloadId = 0; // QPlaceAttribute()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QPlaceAttribute(QPlaceAttribute)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QPlaceAttribute()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QPlaceAttribute()
                cptr = new ::QPlaceAttribute();
            }
            break;
        }
        case 1: // QPlaceAttribute(const QPlaceAttribute &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QPlaceAttribute cppArg0_local;
            ::QPlaceAttribute *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QPlaceAttribute(QPlaceAttribute)
                cptr = new ::QPlaceAttribute(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QPlaceAttribute >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QPlaceAttributeFunc_isEmpty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isEmpty()const
            bool cppResult = const_cast<const ::QPlaceAttribute *>(cppSelf)->isEmpty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPlaceAttributeFunc_label(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // label()const
            QString cppResult = const_cast<const ::QPlaceAttribute *>(cppSelf)->label();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPlaceAttributeFunc_setLabel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPlaceAttribute::setLabel(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setLabel(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setLabel", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLabel(QString)
            cppSelf->setLabel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceAttributeFunc_setText(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPlaceAttribute::setText(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setText(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setText", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setText(QString)
            cppSelf->setText(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceAttributeFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPlaceAttribute::swap(QPlaceAttribute&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QPlaceAttribute&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QPlaceAttribute cppArg0_local;
        ::QPlaceAttribute *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QPlaceAttribute&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceAttributeFunc_text(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // text()const
            QString cppResult = const_cast<const ::QPlaceAttribute *>(cppSelf)->text();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPlaceAttribute__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QPlaceAttribute_PropertyStrings[] = {
    "label::",
    "text::",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPlaceAttribute_methods[] = {
    {"isEmpty", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttributeFunc_isEmpty), METH_NOARGS, nullptr},
    {"label", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttributeFunc_label), METH_NOARGS, nullptr},
    {"setLabel", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttributeFunc_setLabel), METH_O, nullptr},
    {"setText", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttributeFunc_setText), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttributeFunc_swap), METH_O, nullptr},
    {"text", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttributeFunc_text), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QPlaceAttribute__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QPlaceAttribute_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), (pyArg)))) {
                // operator!=(const QPlaceAttribute &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPlaceAttribute cppArg0_local;
                ::QPlaceAttribute *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), (pyArg)))) {
                // operator==(const QPlaceAttribute &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPlaceAttribute cppArg0_local;
                ::QPlaceAttribute *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QPlaceAttribute_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPlaceAttribute_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPlaceAttribute_Type = nullptr;
static PyTypeObject *Sbk_QPlaceAttribute_TypeF(void)
{
    return _Sbk_QPlaceAttribute_Type;
}

static PyType_Slot Sbk_QPlaceAttribute_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPlaceAttribute_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPlaceAttribute_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QPlaceAttribute_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPlaceAttribute_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QPlaceAttribute_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPlaceAttribute_spec = {
    "2:PySide6.QtLocation.QPlaceAttribute",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPlaceAttribute_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QPlaceAttribute_PythonToCpp_QPlaceAttribute_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPlaceAttribute_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QPlaceAttribute_PythonToCpp_QPlaceAttribute_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPlaceAttribute_TypeF()))
        return QPlaceAttribute_PythonToCpp_QPlaceAttribute_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QPlaceAttribute_PTR_CppToPython_QPlaceAttribute(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QPlaceAttribute_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QPlaceAttribute_COPY_CppToPython_QPlaceAttribute(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QPlaceAttribute *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QPlaceAttribute_TypeF(), new ::QPlaceAttribute(*source), true, true);
}

// Python to C++ copy conversion.
static void QPlaceAttribute_PythonToCpp_QPlaceAttribute_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QPlaceAttribute *>(cppOut) = *reinterpret_cast< ::QPlaceAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QPlaceAttribute_PythonToCpp_QPlaceAttribute_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QPlaceAttribute_TypeF()))
        return QPlaceAttribute_PythonToCpp_QPlaceAttribute_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QPlaceAttribute_SignatureStrings[] = {
    "1:PySide6.QtLocation.QPlaceAttribute(self)",
    "0:PySide6.QtLocation.QPlaceAttribute(self,other:PySide6.QtLocation.QPlaceAttribute)",
    "PySide6.QtLocation.QPlaceAttribute.isEmpty(self)->bool",
    "PySide6.QtLocation.QPlaceAttribute.label(self)->QString",
    "PySide6.QtLocation.QPlaceAttribute.setLabel(self,label:QString)",
    "PySide6.QtLocation.QPlaceAttribute.setText(self,text:QString)",
    "PySide6.QtLocation.QPlaceAttribute.swap(self,other:PySide6.QtLocation.QPlaceAttribute)",
    "PySide6.QtLocation.QPlaceAttribute.text(self)->QString",
    "PySide6.QtLocation.QPlaceAttribute.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QPlaceAttribute_SignatureByteSize = 150;
static constexpr uint8_t QPlaceAttribute_SignatureBytes[150] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0xf1, 0xc9,
    0x4f, 0x4e, 0x2c, 0xc9, 0xcc, 0xcf, 0xd3, 0x0b, 0x0c, 0xc8, 0x49, 0x4c, 0x4e, 0x75, 0x2c, 0x29,
    0x29, 0xca, 0x4c, 0x2a, 0x2d, 0x49, 0xd5, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4, 0x32, 0x20, 0x56,
    0xa9, 0x4e, 0x7e, 0x49, 0x46, 0x6a, 0x11, 0x11, 0xaa, 0x35, 0xb9, 0x08, 0xab, 0xd1, 0xcb, 0x2c,
    0x76, 0xcd, 0x2d, 0x28, 0xa9, 0x84, 0x38, 0x42, 0xd7, 0x2e, 0x29, 0x3f, 0x3f, 0x87, 0x18, 0x6d,
    0x39, 0x89, 0x49, 0xa9, 0x39, 0x30, 0x4d, 0x81, 0xc1, 0x40, 0xe1, 0xbc, 0x74, 0x62, 0xf4, 0x15,
    0xa7, 0x96, 0xf8, 0xc0, 0xb5, 0xea, 0x80, 0x4d, 0xb1, 0x82, 0x6a, 0xd7, 0x24, 0x52, 0x7f, 0x48,
    0x6a, 0x45, 0x09, 0x44, 0x7b, 0x09, 0x90, 0x45, 0x9a, 0xee, 0xf2, 0xc4, 0x02, 0x1a, 0x84, 0x61,
    0x09, 0xcc, 0x45, 0xa4, 0x85, 0x45, 0x7c, 0x7c, 0x72, 0x7e, 0x41, 0x65, 0x7c, 0xbc, 0x86, 0x26,
    0x17, 0x00, 0x69, 0xf9, 0xc8, 0xa0
};
#endif

PyTypeObject *init_QPlaceAttribute(PyObject *module)
{
    if (SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX].type != nullptr)
        return SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX].type;

    Shiboken::AutoDecRef Sbk_QPlaceAttribute_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QPlaceAttribute_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QPlaceAttribute",
        "QPlaceAttribute",
        &Sbk_QPlaceAttribute_spec,
        &Shiboken::callCppDestructor< ::QPlaceAttribute >,
        Sbk_QPlaceAttribute_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QPlaceAttribute_TypeF(); // references _Sbk_QPlaceAttribute_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QPlaceAttribute_SignatureStrings);
#else
    InitSignatureBytes(pyType, QPlaceAttribute_SignatureBytes, QPlaceAttribute_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPlaceAttribute_PropertyStrings);
    SbkPySide6_QtLocationTypeStructs[SBK_QPlaceAttribute_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QPlaceAttribute_PythonToCpp_QPlaceAttribute_PTR,
        is_QPlaceAttribute_PythonToCpp_QPlaceAttribute_PTR_Convertible,
        QPlaceAttribute_PTR_CppToPython_QPlaceAttribute,
        QPlaceAttribute_COPY_CppToPython_QPlaceAttribute);

    Shiboken::Conversions::registerConverterName(converter, "QPlaceAttribute");
    Shiboken::Conversions::registerConverterName(converter, "QPlaceAttribute*");
    Shiboken::Conversions::registerConverterName(converter, "QPlaceAttribute&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPlaceAttribute).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QPlaceAttribute_PythonToCpp_QPlaceAttribute_COPY,
        is_QPlaceAttribute_PythonToCpp_QPlaceAttribute_COPY_Convertible);

    qRegisterMetaType< ::QPlaceAttribute >("QPlaceAttribute");

    return pyType;
}

PyTypeObject *init_QPlaceAttributeStaticFields(PyObject *module)
{
    auto *obType = PyObject_GetAttrString(module, "QPlaceAttribute");
    auto *type = reinterpret_cast<PyTypeObject *>(obType);
    Shiboken::AutoDecRef dict(PepType_GetDict(type));
    PyDict_SetItemString(dict, "OpeningHours",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceAttribute::OpeningHours));
    PyDict_SetItemString(dict, "Payment",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceAttribute::Payment));
    PyDict_SetItemString(dict, "Provider",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceAttribute::Provider));
    return type;
}
