// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qdnstlsassociationrecord_wrapper.h"

// Argument includes
#include <QString>
#include <QtNetwork/qdnslookup.h>
#include <qbytearray.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDnsTlsAssociationRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDnsTlsAssociationRecord >()))
        return -1;

    ::QDnsTlsAssociationRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDnsTlsAssociationRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDnsTlsAssociationRecord::QDnsTlsAssociationRecord()
    // 1: QDnsTlsAssociationRecord::QDnsTlsAssociationRecord(QDnsTlsAssociationRecord)
    if (numArgs == 0) {
        overloadId = 0; // QDnsTlsAssociationRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDnsTlsAssociationRecord(QDnsTlsAssociationRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDnsTlsAssociationRecord()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsTlsAssociationRecord()
                cptr = new ::QDnsTlsAssociationRecord();
            }
            break;
        }
        case 1: // QDnsTlsAssociationRecord(const QDnsTlsAssociationRecord &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDnsTlsAssociationRecord cppArg0_local;
            ::QDnsTlsAssociationRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsTlsAssociationRecord(QDnsTlsAssociationRecord)
                cptr = new ::QDnsTlsAssociationRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDnsTlsAssociationRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_matchType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // matchType()const
            QDnsTlsAssociationRecord::MatchingType cppResult = const_cast<const ::QDnsTlsAssociationRecord *>(cppSelf)->matchType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_MatchingType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QDnsTlsAssociationRecord *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_selector(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // selector()const
            QDnsTlsAssociationRecord::Selector cppResult = const_cast<const ::QDnsTlsAssociationRecord *>(cppSelf)->selector();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_Selector_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDnsTlsAssociationRecord::swap(QDnsTlsAssociationRecord&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QDnsTlsAssociationRecord&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDnsTlsAssociationRecord cppArg0_local;
        ::QDnsTlsAssociationRecord *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QDnsTlsAssociationRecord&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_timeToLive(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // timeToLive()const
            quint32 cppResult = const_cast<const ::QDnsTlsAssociationRecord *>(cppSelf)->timeToLive();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_usage(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // usage()const
            QDnsTlsAssociationRecord::CertificateUsage cppResult = const_cast<const ::QDnsTlsAssociationRecord *>(cppSelf)->usage();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_CertificateUsage_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTlsAssociationRecordFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // value()const
            QByteArray cppResult = const_cast<const ::QDnsTlsAssociationRecord *>(cppSelf)->value();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTlsAssociationRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDnsTlsAssociationRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QDnsTlsAssociationRecord_EnumFlagInfo[] = {
    "CertificateUsage:Enum",
    "MatchingType:Enum",
    "Selector:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDnsTlsAssociationRecord_methods[] = {
    {"matchType", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_matchType), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_name), METH_NOARGS, nullptr},
    {"selector", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_selector), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_swap), METH_O, nullptr},
    {"timeToLive", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_timeToLive), METH_NOARGS, nullptr},
    {"usage", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_usage), METH_NOARGS, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecordFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDnsTlsAssociationRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDnsTlsAssociationRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDnsTlsAssociationRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDnsTlsAssociationRecord_Type = nullptr;
static PyTypeObject *Sbk_QDnsTlsAssociationRecord_TypeF(void)
{
    return _Sbk_QDnsTlsAssociationRecord_Type;
}

static PyType_Slot Sbk_QDnsTlsAssociationRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDnsTlsAssociationRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDnsTlsAssociationRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDnsTlsAssociationRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDnsTlsAssociationRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDnsTlsAssociationRecord_spec = {
    "2:PySide6.QtNetwork.QDnsTlsAssociationRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDnsTlsAssociationRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QDnsTlsAssociationRecord_CertificateUsage(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDnsTlsAssociationRecord::CertificateUsage>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDnsTlsAssociationRecord::CertificateUsage *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QDnsTlsAssociationRecord_CertificateUsage_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_CertificateUsage_IDX])))
        return Enum_PythonToCpp_QDnsTlsAssociationRecord_CertificateUsage;
    return {};
}

static PyObject *QDnsTlsAssociationRecord_CertificateUsage_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QDnsTlsAssociationRecord::CertificateUsage>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QDnsTlsAssociationRecord::CertificateUsage *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_CertificateUsage_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QDnsTlsAssociationRecord_Selector(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDnsTlsAssociationRecord::Selector>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDnsTlsAssociationRecord::Selector *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QDnsTlsAssociationRecord_Selector_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_Selector_IDX])))
        return Enum_PythonToCpp_QDnsTlsAssociationRecord_Selector;
    return {};
}

static PyObject *QDnsTlsAssociationRecord_Selector_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QDnsTlsAssociationRecord::Selector>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QDnsTlsAssociationRecord::Selector *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_Selector_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QDnsTlsAssociationRecord_MatchingType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDnsTlsAssociationRecord::MatchingType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDnsTlsAssociationRecord::MatchingType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QDnsTlsAssociationRecord_MatchingType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_MatchingType_IDX])))
        return Enum_PythonToCpp_QDnsTlsAssociationRecord_MatchingType;
    return {};
}

static PyObject *QDnsTlsAssociationRecord_MatchingType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QDnsTlsAssociationRecord::MatchingType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QDnsTlsAssociationRecord::MatchingType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_MatchingType_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDnsTlsAssociationRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsTlsAssociationRecord_TypeF()))
        return QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDnsTlsAssociationRecord_PTR_CppToPython_QDnsTlsAssociationRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QDnsTlsAssociationRecord_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QDnsTlsAssociationRecord_COPY_CppToPython_QDnsTlsAssociationRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDnsTlsAssociationRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDnsTlsAssociationRecord_TypeF(), new ::QDnsTlsAssociationRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDnsTlsAssociationRecord *>(cppOut) = *reinterpret_cast< ::QDnsTlsAssociationRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsTlsAssociationRecord_TypeF()))
        return QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QDnsTlsAssociationRecord_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QDnsTlsAssociationRecord(self)",
    "0:PySide6.QtNetwork.QDnsTlsAssociationRecord(self,other:PySide6.QtNetwork.QDnsTlsAssociationRecord)",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.matchType(self)->PySide6.QtNetwork.QDnsTlsAssociationRecord.MatchingType",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.name(self)->QString",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.selector(self)->PySide6.QtNetwork.QDnsTlsAssociationRecord.Selector",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.swap(self,other:PySide6.QtNetwork.QDnsTlsAssociationRecord)",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.timeToLive(self)->quint32",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.usage(self)->PySide6.QtNetwork.QDnsTlsAssociationRecord.CertificateUsage",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.value(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtNetwork.QDnsTlsAssociationRecord.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QDnsTlsAssociationRecord_SignatureByteSize = 202;
static constexpr uint8_t QDnsTlsAssociationRecord_SignatureBytes[202] = {
    0x78, 0xda, 0xbd, 0x91, 0x31, 0x6f, 0xc2, 0x40, 0x0c, 0x85, 0xf7, 0xfc, 0x12, 0x22, 0xd1, 0xa8,
    0x80, 0xd4, 0xa1, 0x43, 0xa5, 0x14, 0x46, 0x40, 0xa4, 0x09, 0x73, 0x74, 0x3a, 0x0c, 0x58, 0x24,
    0xe7, 0xe0, 0x73, 0x40, 0xf7, 0xef, 0x9b, 0xa8, 0x28, 0x53, 0x07, 0x9c, 0x81, 0xdd, 0xdf, 0xfb,
    0x9e, 0xfc, 0x66, 0x9f, 0xbb, 0x90, 0xe3, 0x01, 0x3e, 0x92, 0x4c, 0xb6, 0x20, 0x77, 0xe2, 0x4b,
    0x92, 0xad, 0x9c, 0x2f, 0x2a, 0x9f, 0x7a, 0x4f, 0x16, 0x8d, 0x20, 0xb9, 0x1f, 0xb0, 0xc4, 0x87,
    0x89, 0x87, 0xea, 0x18, 0x47, 0xef, 0x5a, 0x64, 0x4a, 0x72, 0x06, 0x56, 0x50, 0x71, 0xf4, 0xfc,
    0x6d, 0x52, 0x1b, 0xb1, 0xe7, 0x22, 0x34, 0xf0, 0x57, 0xef, 0xed, 0x4b, 0xc1, 0x6e, 0x7a, 0x16,
    0xdd, 0xa9, 0xc7, 0x35, 0x4e, 0x67, 0xea, 0x41, 0x97, 0xe5, 0xc2, 0x5d, 0x84, 0x06, 0xef, 0x48,
    0xb0, 0x42, 0x3c, 0xa2, 0x71, 0xfe, 0x40, 0x55, 0xba, 0xbb, 0x69, 0x5e, 0x30, 0x84, 0x60, 0x0d,
    0x05, 0xad, 0xf1, 0x36, 0xbc, 0xe6, 0xda, 0xa2, 0x93, 0xc5, 0x5c, 0x13, 0xd2, 0x7a, 0x73, 0x1a,
    0xb3, 0xe4, 0x12, 0x58, 0xf0, 0x88, 0xd6, 0x08, 0xec, 0xfb, 0x08, 0x8d, 0xf3, 0x66, 0xaa, 0xf6,
    0x1f, 0xe7, 0x92, 0x18, 0x92, 0xec, 0x3b, 0x08, 0xa4, 0xcc, 0x26, 0x68, 0x12, 0xcb, 0xd2, 0x52,
    0x13, 0xca, 0x72, 0x12, 0x47, 0xbf, 0x50, 0xb9, 0x40, 0xd2
};
#endif

PyTypeObject *init_QDnsTlsAssociationRecord(PyObject *module)
{
    if (SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX].type != nullptr)
        return SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX].type;

    Shiboken::AutoDecRef Sbk_QDnsTlsAssociationRecord_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDnsTlsAssociationRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDnsTlsAssociationRecord",
        "QDnsTlsAssociationRecord",
        &Sbk_QDnsTlsAssociationRecord_spec,
        &Shiboken::callCppDestructor< ::QDnsTlsAssociationRecord >,
        Sbk_QDnsTlsAssociationRecord_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDnsTlsAssociationRecord_TypeF(); // references _Sbk_QDnsTlsAssociationRecord_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QDnsTlsAssociationRecord_SignatureStrings);
#else
    InitSignatureBytes(pyType, QDnsTlsAssociationRecord_SignatureBytes, QDnsTlsAssociationRecord_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDnsTlsAssociationRecord_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_PTR,
        is_QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_PTR_Convertible,
        QDnsTlsAssociationRecord_PTR_CppToPython_QDnsTlsAssociationRecord,
        QDnsTlsAssociationRecord_COPY_CppToPython_QDnsTlsAssociationRecord);

    Shiboken::Conversions::registerConverterName(converter, "QDnsTlsAssociationRecord");
    Shiboken::Conversions::registerConverterName(converter, "QDnsTlsAssociationRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QDnsTlsAssociationRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDnsTlsAssociationRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_COPY,
        is_QDnsTlsAssociationRecord_PythonToCpp_QDnsTlsAssociationRecord_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QDnsTlsAssociationRecord_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'CertificateUsage'.
    const char *CertificateUsage_Initializer[] = {
        "CertificateAuthorityConstrait",
        "ServiceCertificateConstraint",
        "TrustAnchorAssertion",
        "DomainIssuedCertificate",
        "PrivateUse",
        "PKIX_TA",
        "PKIX_EE",
        "DANE_TA",
        "DANE_EE",
        "PrivCert",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t CertificateUsage_InitializerValues[] = {
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::CertificateAuthorityConstrait), //  0x00  0
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::ServiceCertificateConstraint),  //  0x01  1
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::TrustAnchorAssertion),          //  0x02  2
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::DomainIssuedCertificate),       //  0x03  3
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::PrivateUse),                    //  0xff  255
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::PKIX_TA),                       //  0x00  0
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::PKIX_EE),                       //  0x01  1
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::DANE_TA),                       //  0x02  2
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::DANE_EE),                       //  0x03  3
        uint8_t(QDnsTlsAssociationRecord::CertificateUsage::PrivCert)                       //  0xff  255
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDnsTlsAssociationRecord_TypeF(),
        "2:PySide6.QtNetwork.QDnsTlsAssociationRecord.CertificateUsage",
        CertificateUsage_Initializer, CertificateUsage_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_CertificateUsage_IDX].type = EType;
    // Register converter for enum 'QDnsTlsAssociationRecord::CertificateUsage'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDnsTlsAssociationRecord_CertificateUsage_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QDnsTlsAssociationRecord_CertificateUsage,
            is_Enum_PythonToCpp_QDnsTlsAssociationRecord_CertificateUsage_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QDnsTlsAssociationRecord::CertificateUsage");
        Shiboken::Conversions::registerConverterAlias(converter, "CertificateUsage");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'CertificateUsage' enum.

    // Initialization of enum 'Selector'.
    const char *Selector_Initializer[] = {
        "FullCertificate",
        "SubjectPublicKeyInfo",
        "PrivateUse",
        "Cert",
        "SPKI",
        "PrivSel",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t Selector_InitializerValues[] = {
        uint8_t(QDnsTlsAssociationRecord::Selector::FullCertificate),      //  0x00  0
        uint8_t(QDnsTlsAssociationRecord::Selector::SubjectPublicKeyInfo), //  0x01  1
        uint8_t(QDnsTlsAssociationRecord::Selector::PrivateUse),           //  0xff  255
        uint8_t(QDnsTlsAssociationRecord::Selector::Cert),                 //  0x00  0
        uint8_t(QDnsTlsAssociationRecord::Selector::SPKI),                 //  0x01  1
        uint8_t(QDnsTlsAssociationRecord::Selector::PrivSel)               //  0xff  255
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDnsTlsAssociationRecord_TypeF(),
        "2:PySide6.QtNetwork.QDnsTlsAssociationRecord.Selector",
        Selector_Initializer, Selector_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_Selector_IDX].type = EType;
    // Register converter for enum 'QDnsTlsAssociationRecord::Selector'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDnsTlsAssociationRecord_Selector_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QDnsTlsAssociationRecord_Selector,
            is_Enum_PythonToCpp_QDnsTlsAssociationRecord_Selector_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QDnsTlsAssociationRecord::Selector");
        Shiboken::Conversions::registerConverterAlias(converter, "Selector");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'Selector' enum.

    // Initialization of enum 'MatchingType'.
    const char *MatchingType_Initializer[] = {
        "Exact",
        "Sha256",
        "Sha512",
        "PrivateUse",
        "PrivMatch",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t MatchingType_InitializerValues[] = {
        uint8_t(QDnsTlsAssociationRecord::MatchingType::Exact),      //  0x00  0
        uint8_t(QDnsTlsAssociationRecord::MatchingType::Sha256),     //  0x01  1
        uint8_t(QDnsTlsAssociationRecord::MatchingType::Sha512),     //  0x02  2
        uint8_t(QDnsTlsAssociationRecord::MatchingType::PrivateUse), //  0xff  255
        uint8_t(QDnsTlsAssociationRecord::MatchingType::PrivMatch)   //  0xff  255
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDnsTlsAssociationRecord_TypeF(),
        "2:PySide6.QtNetwork.QDnsTlsAssociationRecord.MatchingType",
        MatchingType_Initializer, MatchingType_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTlsAssociationRecord_MatchingType_IDX].type = EType;
    // Register converter for enum 'QDnsTlsAssociationRecord::MatchingType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDnsTlsAssociationRecord_MatchingType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QDnsTlsAssociationRecord_MatchingType,
            is_Enum_PythonToCpp_QDnsTlsAssociationRecord_MatchingType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QDnsTlsAssociationRecord::MatchingType");
        Shiboken::Conversions::registerConverterAlias(converter, "MatchingType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'MatchingType' enum.

    qRegisterMetaType< ::QDnsTlsAssociationRecord >("QDnsTlsAssociationRecord");
    qRegisterMetaType< ::QDnsTlsAssociationRecord::CertificateUsage >("QDnsTlsAssociationRecord::CertificateUsage");
    qRegisterMetaType< ::QDnsTlsAssociationRecord::Selector >("QDnsTlsAssociationRecord::Selector");
    qRegisterMetaType< ::QDnsTlsAssociationRecord::MatchingType >("QDnsTlsAssociationRecord::MatchingType");

    return pyType;
}
