// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qsslcertificateextension_wrapper.h"

// Argument includes
#include <QString>
#include <QtNetwork/qsslcertificateextension.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSslCertificateExtension_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSslCertificateExtension >()))
        return -1;

    ::QSslCertificateExtension *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QSslCertificateExtension", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QSslCertificateExtension::QSslCertificateExtension()
    // 1: QSslCertificateExtension::QSslCertificateExtension(QSslCertificateExtension)
    if (numArgs == 0) {
        overloadId = 0; // QSslCertificateExtension()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QSslCertificateExtension(QSslCertificateExtension)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QSslCertificateExtension()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSslCertificateExtension()
                cptr = new ::QSslCertificateExtension();
            }
            break;
        }
        case 1: // QSslCertificateExtension(const QSslCertificateExtension &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSslCertificateExtension cppArg0_local;
            ::QSslCertificateExtension *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QSslCertificateExtension(QSslCertificateExtension)
                cptr = new ::QSslCertificateExtension(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSslCertificateExtension >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSslCertificateExtensionFunc_isCritical(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isCritical()const
            bool cppResult = const_cast<const ::QSslCertificateExtension *>(cppSelf)->isCritical();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslCertificateExtensionFunc_isSupported(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isSupported()const
            bool cppResult = const_cast<const ::QSslCertificateExtension *>(cppSelf)->isSupported();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslCertificateExtensionFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QSslCertificateExtension *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslCertificateExtensionFunc_oid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // oid()const
            QString cppResult = const_cast<const ::QSslCertificateExtension *>(cppSelf)->oid();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslCertificateExtensionFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslCertificateExtension::swap(QSslCertificateExtension&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QSslCertificateExtension&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSslCertificateExtension cppArg0_local;
        ::QSslCertificateExtension *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QSslCertificateExtension&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSslCertificateExtensionFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // value()const
            QVariant cppResult = const_cast<const ::QSslCertificateExtension *>(cppSelf)->value();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslCertificateExtension__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSslCertificateExtension_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSslCertificateExtension_methods[] = {
    {"isCritical", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtensionFunc_isCritical), METH_NOARGS, nullptr},
    {"isSupported", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtensionFunc_isSupported), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtensionFunc_name), METH_NOARGS, nullptr},
    {"oid", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtensionFunc_oid), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtensionFunc_swap), METH_O, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtensionFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSslCertificateExtension__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSslCertificateExtension_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSslCertificateExtension_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSslCertificateExtension_Type = nullptr;
static PyTypeObject *Sbk_QSslCertificateExtension_TypeF(void)
{
    return _Sbk_QSslCertificateExtension_Type;
}

static PyType_Slot Sbk_QSslCertificateExtension_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSslCertificateExtension_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSslCertificateExtension_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSslCertificateExtension_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSslCertificateExtension_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSslCertificateExtension_spec = {
    "2:PySide6.QtNetwork.QSslCertificateExtension",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSslCertificateExtension_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSslCertificateExtension_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSslCertificateExtension_TypeF()))
        return QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSslCertificateExtension_PTR_CppToPython_QSslCertificateExtension(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QSslCertificateExtension_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QSslCertificateExtension_COPY_CppToPython_QSslCertificateExtension(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSslCertificateExtension *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSslCertificateExtension_TypeF(), new ::QSslCertificateExtension(*source), true, true);
}

// Python to C++ copy conversion.
static void QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSslCertificateExtension *>(cppOut) = *reinterpret_cast< ::QSslCertificateExtension *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSslCertificateExtension_TypeF()))
        return QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QSslCertificateExtension_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QSslCertificateExtension(self)",
    "0:PySide6.QtNetwork.QSslCertificateExtension(self,other:PySide6.QtNetwork.QSslCertificateExtension)",
    "PySide6.QtNetwork.QSslCertificateExtension.isCritical(self)->bool",
    "PySide6.QtNetwork.QSslCertificateExtension.isSupported(self)->bool",
    "PySide6.QtNetwork.QSslCertificateExtension.name(self)->QString",
    "PySide6.QtNetwork.QSslCertificateExtension.oid(self)->QString",
    "PySide6.QtNetwork.QSslCertificateExtension.swap(self,other:PySide6.QtNetwork.QSslCertificateExtension)",
    "PySide6.QtNetwork.QSslCertificateExtension.value(self)->QVariant",
    "PySide6.QtNetwork.QSslCertificateExtension.__copy__()",
    nullptr}; // Sentinel
#else
static constexpr size_t QSslCertificateExtension_SignatureByteSize = 156;
static constexpr uint8_t QSslCertificateExtension_SignatureBytes[156] = {
    0x78, 0xda, 0xbd, 0x90, 0x31, 0x0b, 0xc2, 0x30, 0x10, 0x85, 0xf7, 0xfe, 0x92, 0x16, 0x34, 0xd8,
    0xc5, 0xc1, 0xc1, 0xa5, 0xb8, 0x8a, 0x21, 0xe0, 0x1a, 0x62, 0x7b, 0xd5, 0xc3, 0x98, 0x0b, 0x97,
    0xab, 0xb5, 0xff, 0x5e, 0x41, 0xc4, 0xd5, 0x28, 0xb8, 0x1e, 0xef, 0xfb, 0x78, 0xef, 0xea, 0xd5,
    0x6e, 0x32, 0xd8, 0xc1, 0x52, 0x69, 0xd9, 0x82, 0x8c, 0xc4, 0x67, 0xa5, 0x4d, 0xf2, 0x0d, 0xb0,
    0x60, 0x8f, 0xad, 0x13, 0xd8, 0xdc, 0x04, 0x42, 0x42, 0x0a, 0x65, 0x02, 0xdf, 0x57, 0xc5, 0x22,
    0x17, 0x99, 0x91, 0x9c, 0x80, 0x33, 0xa8, 0xaa, 0xf8, 0x3c, 0xab, 0x30, 0x35, 0x8c, 0xf2, 0x38,
    0xfa, 0x67, 0xbf, 0xf9, 0xfa, 0x40, 0xe4, 0xf3, 0x0c, 0x66, 0x88, 0x91, 0x58, 0xa0, 0xfb, 0x56,
    0x11, 0xdc, 0x05, 0x5e, 0xac, 0x36, 0xc2, 0x18, 0x8e, 0x39, 0x38, 0x61, 0xf7, 0x03, 0x9d, 0x46,
    0x17, 0xff, 0xf0, 0xe8, 0xab, 0xf3, 0xc3, 0x7b, 0xe4, 0xde, 0x31, 0xba, 0x20, 0x39, 0x02, 0x6b,
    0x5b, 0x8a, 0x93, 0xb5, 0x65, 0x55, 0xdc, 0x01, 0x8f, 0xc2, 0xea, 0x8b
};
#endif

PyTypeObject *init_QSslCertificateExtension(PyObject *module)
{
    if (SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX].type != nullptr)
        return SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX].type;

    Shiboken::AutoDecRef Sbk_QSslCertificateExtension_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSslCertificateExtension_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSslCertificateExtension",
        "QSslCertificateExtension",
        &Sbk_QSslCertificateExtension_spec,
        &Shiboken::callCppDestructor< ::QSslCertificateExtension >,
        Sbk_QSslCertificateExtension_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSslCertificateExtension_TypeF(); // references _Sbk_QSslCertificateExtension_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QSslCertificateExtension_SignatureStrings);
#else
    InitSignatureBytes(pyType, QSslCertificateExtension_SignatureBytes, QSslCertificateExtension_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSslCertificateExtension_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificateExtension_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_PTR,
        is_QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_PTR_Convertible,
        QSslCertificateExtension_PTR_CppToPython_QSslCertificateExtension,
        QSslCertificateExtension_COPY_CppToPython_QSslCertificateExtension);

    Shiboken::Conversions::registerConverterName(converter, "QSslCertificateExtension");
    Shiboken::Conversions::registerConverterName(converter, "QSslCertificateExtension*");
    Shiboken::Conversions::registerConverterName(converter, "QSslCertificateExtension&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSslCertificateExtension).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_COPY,
        is_QSslCertificateExtension_PythonToCpp_QSslCertificateExtension_COPY_Convertible);

    qRegisterMetaType< ::QSslCertificateExtension >("QSslCertificateExtension");

    return pyType;
}
